// ManageFabric.js

var MANAGE_FABRIC_PAGE = current_context + "/faces/page/rbce/fabric/ManageFabric.jsp"

//////////////////////////////////////// SHELL /////////////////////////////////////////////
function initializeShell()
{
	resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame'); 
	resizeFrameWidth('staticLoadingFrame', 'staticLoadingFrame');
}

function startShellLoading()
{
	parent.document.getElementById('staticLoadingDiv').style.display='block'; 
	parent.document.getElementById('dynamicDiv').style.visibility='hidden';
	
	// Make the dynamic frame very small
	parent.document.getElementById('dynamicFrame').style.width = "1px";
	parent.document.getElementById('dynamicFrame').style.height = "1px";

	parent.resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame'); 
	parent.resizeFrameWidth('staticLoadingFrame', 'staticLoadingFrame');
	
	document.getElementById(namespace_g + 'lastRefreshTimestamp').innerHTML = document.getElementById(namespace_g + "hiddenNLSRefreshingData").value;
}

function stopShellLoading()
{
	parent.document.getElementById('staticLoadingDiv').style.display='none'; 
	parent.document.getElementById('dynamicDiv').style.visibility='visible';
	
	parent.resizeFrameWidth("dynamicFrame", "dynamicFrame");
	parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
}

function refresh()
{
	document.getElementById('dynamicFrame').src = MANAGE_FABRIC_PAGE;
	
	startShellLoading();
}

/////////////////////////////////////////////////////////////////////////////////////

function activateActionButtons()
{
	document.getElementById(namespace_g+"mainForm:modifyButton").disabled = false;
	document.getElementById(namespace_g+"mainForm:activateButton").disabled = false;
}

function disableActionButtons()
{
	if(document.getElementById(namespace_g+"mainForm:modifyButton"))
		document.getElementById(namespace_g+"mainForm:modifyButton").disabled = true;
	
	if(document.getElementById(namespace_g+"mainForm:activateButton"))
		document.getElementById(namespace_g+"mainForm:activateButton").disabled = true;
	alignHeaderTableAndContentTable('headerTableDivId','zoningConfigsTable');
	
	// Show the last refresh
	document.getElementById(namespace_g + 'lastRefreshTimestamp').innerHTML = getLocalizedCurrentTimeStamp();	
}

function activateModalSetUp()
{
	// The user will select a configuration and click activate
	// the selected config needs to show up in the modal
	
	radioButtons = document.getElementsByName('zoneStore');
	var selectedIndex = "";
	
	for(x = 0; x < radioButtons.length; x++)
	{
		if(radioButtons[x].checked)
		{
			selectedIndex = radioButtons[x].value;
			break;
		}
	}

	// selectedIndex will always be defined because the active button is only activated when
	// the user selects an item
	
	var name = eval("config" + selectedIndex + "Name");
	
	// Set the name in the activate modal
	document.getElementById("selectedConfig").innerHTML = name;
}

function showBackupSwitchConfigurations()
{
	// Hide all the tables except for the one that is selected
	var options = document.getElementById("backupAllSwitchMenu").options;
	
	for(x = 0; x < options.length; x++)
	{
		// The option value will be table ID
		table = document.getElementById(options[x].value);
		
		if(table)
		{
			table.style.display="none";
		}
	}
	
	// Show the selected one
	selectedId = options[document.getElementById("backupAllSwitchMenu").selectedIndex].value;
	document.getElementById(selectedId).style.display="block";
}

function backupAll()
{
	document.getElementById(namespace_g+ "myForm:manageFabricBackupAllOK").disabled = true;
	document.getElementById(namespace_g+ "myForm:manageFabricBackupAllCancel").disabled = true;
	showProgressIndicator("spinningDiv_backupAllModal");
	
	//send ajax call to save the cfg from device to server.
	backupAll_saveFileToServer();
}

function launchBackupAllDialog(){
	setUtilDialogTitle(document.getElementById(namespace_g+ 'mainForm:backupAllTitleStr').innerHTML);
	
	adjustDialogSize(400,230);
	
	document.getElementById("templ_u_iframe").src=backupDialogPath;
}

function onLoad_BackupAllConfigurations(){
	initErrorMessage();
	parent.stopWait();
}

function backupAll_CancleClick(){
	parent.document.getElementById(namespace_g+'mainForm:util_dialog_backupall_closer').click();
}

/**
* new an Ajax request
*/
function backupAll_newXMLHttpRequest() 
{
	var xmlreq = false;

	if (window.XMLHttpRequest) {
    	// Create XMLHttpRequest object in non-Microsoft browsers
    	xmlreq = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) {
	    // Create XMLHttpRequest via MS ActiveX
    	try {
      		// Try to create XMLHttpRequest in later versions
      		// of Internet Explorer
      		xmlreq = new ActiveXObject("Msxml2.XMLHTTP");
		}
    	catch (e1) {
      		// Failed to create required ActiveXObject
      		try {
        		// Try version supported by older versions
        		// of Internet Explorer
        		xmlreq = new ActiveXObject("Microsoft.XMLHTTP");
      		} 
      		catch (e2) {
        		// Unable to create an XMLHttpRequest with ActiveX
      		}
    	}
  	}
	return xmlreq;
}
var bcaReq;
var saveToServerSucceed;
function backupAll_saveFileToServer(){
	// Send request	
	bcaReq = backupAll_newXMLHttpRequest();
	
	// Set callback
	bcaReq.onreadystatechange = backupALL_saveFileToServerCallback;

	// Open connection
	bcaReq.open("POST", backupServletPath + "?id=" + document.getElementById("backupAllSwitchMenu").value, true);
	
	// Set type
	bcaReq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	
	// Send data
	bcaReq.send("");
}


function backupALL_saveFileToServerCallback(){
	if(bcaReq.readyState == 4) {
		if(bcaReq.status == 200) {
			// Checking with index of, because the response text is wite space padded		
			var txt = bcaReq.responseText;
			eval(txt);
			if(saveToServerSucceed){
				parent.document.getElementById("backupAllHiddenFrame").src = backupServletPath + "?toDownload=true";
				backupAll_CancleClick();
			}else if(!saveToServerSucceed){
				innerMessagesInstance.display();
				document.getElementById(namespace_g+ "myForm:manageFabricBackupAllOK").disabled = false;
				document.getElementById(namespace_g+ "myForm:manageFabricBackupAllCancel").disabled = false;
				hideProgressIndicator("spinningDiv_backupAllModal");
			}
		}
	}
}
function restoreConfiguration(type){
    document.getElementById(namespace_g + 'mainForm:restoreType').value = type;
	document.getElementById(namespace_g + 'mainForm:restoreConfigurationButton').click(); 
	return false;
}
