function diskAssimilateStart() {
	document.getElementById(namespace_g + "myForm:assimilate_start_button").click();
}

function onAssimilateStart() {
	document.getElementById("assimilate_complete_row").style.display = "none";
	document.getElementById("assimilate_progressing_row").style.display = "";
	
	document.getElementById(namespace_g + "myForm:confirm_assimilate_complete").disabled = true;
}

function onAssimilateEnd() {
	document.getElementById("assimilate_complete_row").style.display = "";
	document.getElementById("assimilate_progressing_row").style.display = "none";
	
	document.getElementById(namespace_g + "myForm:confirm_assimilate_complete").disabled = false;
}

function onAssimilateError() {
	document.getElementById(namespace_g + "myForm:hide_assimilate_button").click();
	innerMessagesInstance.display();
}

function confirmAssimilate() {
	document.getElementById(namespace_g + "myForm:hide_assimilate_button").click();
	document.getElementById(namespace_g + "myForm:hiddenRefreshBtn").click();
}

var USAGE_TYPE_UNCONFIGURED = 0;
var USAGE_TYPE_CONFIGURED = 1;
var USAGE_TYPE_DEDICATEDSPARE = 2;
var USAGE_TYPE_GLOBALSPARE = 3;


var SelectedDiskObjMap = new JSSimpleMap();

function DiskObject(module,slot,usable,roaming,globalSparing,protectedPools,dismounted,mounted,missing,configured){
	this.module = module;
	this.slot = slot;
	this.usable = usable;
	this.roaming = roaming;
	this.globalSparing = globalSparing;
	this.protectedPools = protectedPools;
	this.dismounted = dismounted;
	this.mounted = mounted;
	this.missing = missing;
	this.configured = configured;
	
	this.getKey = function(){
		return (this.module+"_"+this.slot);
	}
	this.toString = function(){
		return (this.module+"_"+this.slot+"_"+this.usable+"_"+this.roaming+"_"+this.globalSparing);
	}
}

function initDiskMenu(){
	SelectedDiskObjMap = new JSSimpleMap();
	setupVolumeMenus();
	diskOnClicked();
}
function setupVolumeMenus(){
var DiskAllOptions = new Array();
DiskAllOptions[0] =	new Option(document.getElementById(namespace_g + "myForm:menu_1").innerHTML,'MoreAction');
DiskAllOptions[1] = new Option(document.getElementById(namespace_g + "myForm:menu_2").innerHTML,'DiskProperties');
DiskAllOptions[2] = new Option(document.getElementById(namespace_g + "myForm:menu_4").innerHTML,'UnassignSpare');
DiskAllOptions[3] = new Option(document.getElementById(namespace_g + "myForm:menu_5").innerHTML, 'AssimilateDrive');
DiskAllOptions[4] = new Option(document.getElementById(namespace_g + "myForm:menu_6").innerHTML, 'DiskCopyBack');
DiskAllOptions[5] = new Option(document.getElementById(namespace_g + "myForm:menu_7").innerHTML, 'DismountDisk');
DiskAllOptions[6] = new Option(document.getElementById(namespace_g + "myForm:menu_8").innerHTML, 'MountDisk');
 	var menu = document.getElementById("menu2");
	for(var i=0;i<DiskAllOptions.length;i++){
		menu.options[i] = DiskAllOptions[i];
		if(i==0)
		  menu.options[i].key = false;
		else
		  menu.options[i].key = true;
	}
	 emulate("menu2");
}

function diskOnClicked(thisObj,module,slot,usable,roaming,globalSparing,protectedPools,dismounted,mounted,missing,configured){
 	var menu = document.getElementById("menu2");
	for(var i=1;i<menu.options.length;i++){
		menu.options[i].key = true;
	}
	document.getElementById(namespace_g + "myForm:AssignGlobalSpareBtn").disabled = true;
	document.getElementById(namespace_g + "myForm:LocateDriveBtn").disabled = true;
	
 	if(thisObj){
		var diskObj = new DiskObject(module,slot,usable,roaming,globalSparing,protectedPools,dismounted,mounted,missing,configured);
		if(thisObj && thisObj.checked){
			SelectedDiskObjMap.put(diskObj.getKey(),diskObj);
		}else{
			SelectedDiskObjMap.remove(diskObj.getKey());
		}
		
		var allSelectedObjects = SelectedDiskObjMap.valueArray();
		var selectedDiskNumber = SelectedDiskObjMap.length();	
		
		if(selectedDiskNumber == 1){
			menu.options[0].key = false;
			menu.options[1].key = false;
			
			if(allSelectedObjects[0].globalSparing){
				menu.options[2].key = false;
			}
			
			if (allSelectedObjects[0].configured=="true" && allSelectedObjects[0].missing!="true") {
				menu.options[4].key = false;
			}				
		}
		
		if(selectedDiskNumber > 0){
			document.getElementById(namespace_g + "myForm:LocateDriveBtn").disabled = false;
			
			var allUsable = true;
			var allDismounted = true;
			var allMounted = true;
			var allRoaming = true;
			
			for(var i in allSelectedObjects){
				allUsable = allUsable && allSelectedObjects[i].usable;
				allDismounted = (allDismounted && (allSelectedObjects[i].dismounted == "true" && allSelectedObjects[i].missing!="true"));
				allMounted = (allMounted && (allSelectedObjects[i].mounted=="true" && allSelectedObjects[i].configured!="true"));
				allRoaming = allRoaming && allSelectedObjects[i].roaming;
			}
			
			
			if(allUsable){
				document.getElementById(namespace_g + "myForm:AssignGlobalSpareBtn").disabled = false;					
			}
			
			if (allDismounted){
				menu.options[6].key = false;
			}
			
			if(allMounted){
				menu.options[5].key = false;
			}
			
			if (allRoaming) {
				menu.options[3].key = false;
			}
		}		
	}
	emulate("menu2");
	highlightStartRow(namespace_g + "myForm:disksTable");
}

function diskSubmitAction(thisObj){
	 if(isSelectOptionDisabled(thisObj))
		   return;
	var action = thisObj.options[thisObj.options.selectedIndex].value;
	thisObj.value="";
	var allSelectedObjecs = SelectedDiskObjMap.valueArray();
	if(action=="DiskProperties"){
		document.getElementById(namespace_g + 'myForm:viewProperties').click();
		parent.setStorageUtilTitle('diskPropertiesTitle');
//	} else if(action=="AssignDedicatedSpare") {
//		document.getElementById(namespace_g + 'myForm:viewAssignDedicated').click();
//		parent.setStorageUtilTitle('diskAssignUnassignTitle');
	} else if(action=="UnassignSpare") {
			if (""!= allSelectedObjecs[0].protectedPools) {//if unassign global spare will leave pool unprotected, need confirm
				document.getElementById(namespace_g + "myForm:warning_unassignGlobal_unprotectPool_txt").innerHTML = allSelectedObjecs[0].protectedPools;
				document.getElementById(namespace_g + 'myForm:showWarning_unassignGlobal').click();
			}else{
			// add by fengtw, need to ajax submit the action
					disableRefreshButton(false);
					enableDisksButtons(false);
					displayMainContents(false);	
					parent.disableRefreshButton(true);
					document.getElementById(namespace_g + "myForm:LocateDriveBtn").disabled = true;
			// end		
				document.getElementById(namespace_g + 'myForm:unassignSpare_hidden').click();
		}		
	} else if (action == "AssimilateDrive") {
		document.getElementById(namespace_g + "myForm:show_assimilate_button").click();
	} else if (action == "DiskCopyBack") {
		document.getElementById(namespace_g + "myForm:copyBackDiskBtn").click();
		parent.setStorageUtilTitle('CopyBackDiskTitle');
	} else if (action == "DismountDisk") {
		document.getElementById(namespace_g + "myForm:dismountLink").click();
	} else if (action == "MountDisk") {
		document.getElementById(namespace_g + "myForm:mountLink").click();
	}
	thisObj.selectedIndex = 0;
}
function onCopyBackClicked(){
	setFormTargetFromStorage(650,390);
}

/////////////////////////////////// mount/dismount support

//dismounting
function onDismountConfirmShow(){
	var allDrives = "";
	var allSelectedObjecs = SelectedDiskObjMap.valueArray();
	for(var i=0;i<allSelectedObjecs.length;i++){
		allDrives = allDrives+allSelectedObjecs[i].module+":"+allSelectedObjecs[i].slot+",";
	}
	allDrives = allDrives.substring(0,allDrives.length-1);
	document.getElementById("DISKDisplayName").innerHTML=allDrives;
	document.getElementById(namespace_g + 'myForm:dismountOK').disabled = false;
	document.getElementById(namespace_g + 'myForm:dismountCancel').disabled = false;
	hideProgressIndicator("spinningDiv_dismountModal");
	return true;
}
function onDismountingStart(){
	enableSelectedStorageTabs(4);
	return true;
}
function ondismounting(){
	document.getElementById(namespace_g + 'myForm:dismountOK').disabled = true;
	document.getElementById(namespace_g + 'myForm:dismountCancel').disabled = true;
	showProgressIndicator('spinningDiv_dismountModal');
	document.getElementById(namespace_g + 'myForm').target='_self';
	return true;
}
function onDismountingEnd(){
	document.getElementById(namespace_g + "myForm:dismountHiddenBtn").click();
	refreshTabs();
	return true;
}
function refreshTabs(){
	enableAllStorageTabs();
	setTimeout(lazyRefreshTabs,200);
	function lazyRefreshTabs(){	
		parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_DISK);
	}
}
//mounting
function onmountConfirmShow(){
	var allDrives = "";
	var allSelectedObjecs = SelectedDiskObjMap.valueArray();
	for(var i=0;i<allSelectedObjecs.length;i++){
		allDrives = allDrives+allSelectedObjecs[i].module+":"+allSelectedObjecs[i].slot+",";
	}
	allDrives = allDrives.substring(0,allDrives.length-1);
	document.getElementById("DISKDisplayName_mount").innerHTML=allDrives;
	document.getElementById(namespace_g + "myForm:mountModalSubmit").click();
	return true;
}
function onMountingStart(){
	enableSelectedStorageTabs(4);
	return true;
}
function onMountingEnd(){	
	document.getElementById(namespace_g + "myForm:mountCancel").click();
	refreshTabs();
	return true;
}
function onmounting(){
	document.getElementById(namespace_g + 'myForm').target='_self';
	return true;
}
function diskAssignGlobalShow(){
	document.getElementById(namespace_g + "myForm:confirm_dialog_left").disabled = false;	  	   
    document.getElementById(namespace_g + "myForm:confirmGlobalSpare_dialog_right").disabled = false;	
	hideProgressIndicator('spinningDiv');
}
///////////////////////////////////////////////ajax assign/unassign global sparing/////////////////
function onSparingFinished(){
	document.getElementById(namespace_g + "myForm:refreshPools").innerHTML="true";
	document.getElementById(namespace_g + 'myForm:confirmHiddenBtn').click();
	document.getElementById(namespace_g + 'myForm:unassignGlobalConfirmHiddenBtn').click();
	//document.getElementById(namespace_g + 'myForm:refreshBtn').click();
	parent.refreshAllTabs(parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_DISK);
	enableAllStorageTabs();	
}
function unassignWarning(){
	  	document.getElementById(namespace_g + 'myForm:confirm_unassignGlobal_dialog_left').disabled = false;
	    document.getElementById(namespace_g + 'myForm:warning_unassignGlobal_close').disabled = false;	   
		hideProgressIndicator('spinningDiv_warning_unassignGlobal');
}
//added by hatteras
function hxBehaviorAdd() {
	hX_5.addBehavior("view:myForm:assignGlobalSparingPanel", "onget", 
		new hX_5.JSFBehaviorAjaxSubmit("progress-actions:LOCKED", "on-error:onSparingFinished();", 
		"on-complete:onSparingFinished();", "on-start:enableSelectedStorageTabs(4);"));
}