// storage.js
var maxQuantity = 128;

//All JavaScript functions in storage package must be in this file
var cachedClickEvent = null;
var ConfigOptions = new Array();

var REFRESH_MASK_VOLUME = 16;
var REFRESH_MASK_POOL = 8;
var REFRESH_MASK_HOST = 4;
var REFRESH_MASK_DISK = 2;
var REFRESH_MASK_CONFIGURATION = 1;

function JSSimpleMap(){
	this.innerMap = new Object();
	this.size = 0;
	this.put = function(key,value){
		if(!this.innerMap[key]){
			this.size++;
		}
		this.innerMap[key] = value;
	}
	this.remove = function(key){	
		if(this.innerMap[key]){
			this.size--;
		}
		this.innerMap[key] = null;
		delete this.innerMap[key];
	}
	this.keyArray = function(){
		var keyAry = new Array();
		for(key in this.innerMap){
			keyAry.push(key);
		}
		return keyAry;
	}
	this.valueArray = function(){
		var valueAry = new Array();
		for(key in this.innerMap){
			valueAry.push(this.innerMap[key]);
		}
		return valueAry;
	}
	this.length = function(){
		return this.size;
	}
}

var subTabCount = 0;
function setFormTargetFromStorage(varwidth,varheight){
    document.getElementById(namespace_g + "myForm").target = "templ_u_iframe";
    parent.adjustDialogSize(varwidth , varheight);	
    parent.document.getElementById(parent.namespace_g + 'myForm:util_dialog_luncher').click();
}
	
function setPoolFormTarget(thisObj,dialogName,width, height){
	if(dialogName == 'util_dialog'){
		if(document.getElementById('templ_waitDiv_utility').src!="")
			document.getElementById('templ_waitDiv_utility').src = "";
		
		thisObj.form.target="templ_u_iframe";
		
		if(width == null){	
			width  = document.body.offsetWidth*0.80; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}
		if(height == null){
			if(hX_5.brw.isIE())
				height  =document.body.offsetHeight*0.85;
			else
				height  = window.outerHeight*0.85; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;		
		}
		document.getElementById(namespace_g + 'myForm:util_dialog_luncher').click();
	}else if(dialogName == 'util_dialog_sec_level'){
		if(document.getElementById('templ_waitDiv_utility_sec_level').src!="")
			document.getElementById('templ_waitDiv_utility_sec_level').src = "";
		thisObj.form.target="templ_u_iframe_sec_level";
		if(width == null){	
			width  = document.body.offsetWidth*0.80; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_dialog_sec_level").style.width = width;
		}else{
			document.getElementById(namespace_g + "myForm:util_dialog_sec_level").style.width = width;
		}
		if(height == null){
			if(hX_5.brw.isIE())
				height  =document.body.offsetHeight*0.85;
			else
				height  = window.outerHeight*0.85; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_dialog_sec_level").style.height = height;
		}else{
			document.getElementById(namespace_g + "myForm:util_dialog_sec_level").style.height = height;		
		}
		document.getElementById(namespace_g + 'myForm:util_dialog_sec_level_luncher').click();
	}
	
		
	return true;
}

 function emulate(menuName) {
	 var e = document.getElementById(menuName);
	 e.className="dmc_outputText";
	 
     for (var i=0, option; option = e.options[i]; i++) {  
         if (!option.key) {  
             option.style.color = "menutext";
             option.setAttribute("aria-disabled","false");  
         }  
         else {  
             option.style.color = "graytext";  
             option.setAttribute("aria-disabled","true");  
         }
     }
 }

function isSelectOptionDisabled(e) {
     if (e.options[e.selectedIndex].key) {  		
		e.selectedIndex = 0;
		return true;
	 }
	 return false;
 }  


function getSelectedTRObj(tableId)
{
    var selectedObject = new Array();
 var elmt = document.getElementById(tableId);
 var tbody = elmt.getElementsByTagName("tbody");
 trs = tbody[0].rows;
 for(var i=0;i<trs.length;i++){
    var node = trs[i];
   while(node){
   node = node.childNodes[0]; 
   if(node.tagName)
      if(node.tagName=="INPUT")
       break;
   }
   if(node.tagName=="INPUT" && node.checked){
     return trs[i];
   }
 }
}

var selectedPoolRelatedDiskNumber = 0;
function selectPoolDisk(thisObj){
	if(thisObj && thisObj.checked){
		selectedPoolRelatedDiskNumber++;
	}else if(thisObj){
		selectedPoolRelatedDiskNumber--;	
	}
	if(selectedPoolRelatedDiskNumber>0){
		document.getElementById(namespace_g + 'myForm:locateDriverButton').disabled = false;
	}
	else {
		document.getElementById(namespace_g + 'myForm:locateDriverButton').disabled = true;
	}
	highlightStartRow(namespace_g + "myForm:storagePoolDiskTable");
}

function toggle(checked, value) {
	var input;
	if(checked) {
		input = document.createElement("input");
		input.setAttribute("type", "hidden");
		input.setAttribute("name", "selectedItem" + value);
		input.setAttribute("id", "selectedItem" + value);
		input.setAttribute("value", value);
		document.getElementById(namespace_g + "myForm").appendChild(input);
	} else {
		input = document.getElementById("selectedItem"+value);
  		document.getElementById(namespace_g + "myForm").removeChild(input);
	}
}

function enableSparingButtons(dialogname) {
	if(dialogname == 'poolAssignDedicated') {
		var elmt = document.getElementById(namespace_g + "myForm:disksTable");
		var tbody = elmt.getElementsByTagName("tbody");
		var selected = false;
 		var trs = tbody[0].rows;
		for(var i=0;i<trs.length;i++){
 			var curr_row = document.getElementById(namespace_g + "myForm:disksTable:" + i + ":rowSelect1");
 			if(curr_row.checked) {
	 			selected = true;
	 			break;
	 		}
   		}
	    if(selected)	
			document.getElementById(namespace_g + 'myForm:poolAssignDedicatedOK').disabled = false;
		else
			document.getElementById(namespace_g + 'myForm:poolAssignDedicatedOK').disabled = true;
	}
}

function enableDisksButtons(flag){
	if(flag){
		document.getElementById("menu2").disabled = false;
	}else{
		document.getElementById("menu2").disabled = true;
		document.getElementById(namespace_g + "myForm:LocateDriveBtn").disabled = true;
		document.getElementById(namespace_g + "myForm:AssignGlobalSpareBtn").disabled = true;
	}
}


function unmapHostAction(){
		document.getElementById(namespace_g + 'myForm:confirm_dialog_left').disabled = false;
		document.getElementById(namespace_g + 'myForm:confirm_dialog_right').disabled = false;
		document.getElementById(namespace_g + 'myForm:unmapHostDialog').click();
}
function unmapHostCompleteAction(){
		//document.getElementById("waiting_unmapHost_div").style.visibility= "visible";

		document.getElementById(namespace_g + 'myForm:confirm_dialog_left').disabled = true;
		document.getElementById(namespace_g + 'myForm:confirm_dialog_right').disabled = true;
		document.getElementById(namespace_g + 'myForm:unmapHostCompleteButton').click();
}
function initSelectedHost(){
	var MAX_HOSTS_NUM = 6;
    var hostChkbox;
    var selectedHostNameArray = new Array();
	for(var i=0;i<MAX_HOSTS_NUM;i++){
        hostChkbox = document.getElementById(namespace_g+"myForm:treeTable:iterator_1:"+i+":rowSelectedHost");
		if( hostChkbox !=null && hostChkbox != undefined){
            if(hostChkbox.checked){
			    selectedHostNameArray.push(hostChkbox.title);
            }
		}else{
            break;
        }
	}
	var strInnerHTML = "<TABLE  cellspacing='0' cellpadding='0' width='50%' height='100%'>";
	for(var i = 0; i < selectedHostNameArray.length; i++){
		strInnerHTML += "<TR height='18px'><TD><SPAN class='dmc_outputText'>" + selectedHostNameArray[i] + "</SPAN></TD></TR>";
	}
	strInnerHTML += "</TABLE>";
	document.getElementById("selectedHostList").innerHTML = strInnerHTML;
}
function closeUtilDialog(){
		/*var _iframe = document.getElementById("templ_u_iframe");
		if(!_iframe){
			_iframe = parent.document.getElementById("templ_u_iframe");		
		}
		if(_iframe){
			_iframe.src="";
			_iframe.style.height="1px";
		}*/
		document.getElementById(namespace_g + 'myForm:util_dialog_closer').click();
		
}

function closeSecLevelUtilDialog(){
		/*var iframe = document.getElementById("templ_u_iframe_sec_level");
		if(!iframe){
			var iframe = parent.document.getElementById("templ_u_iframe_sec_level");		
		}
		if(iframe){
			iframe.src="";
			iframe.style.height="1px";
		}*/
		document.getElementById(namespace_g + 'myForm:util_dialog_sec_level_closer').click();		
}

function updatePoolPiePercentage(){
	var poolTotal = document.getElementById(namespace_g + "myForm:poolTotal").innerHTML;
	var subSystemTotal = document.getElementById(namespace_g + "myForm:subsystemTotal").innerHTML;
	var poolAlocated = document.getElementById(namespace_g + "myForm:poolAllocated").innerHTML;
	var poolPhysical = document.getElementById(namespace_g + "myForm:poolPhysical").innerHTML;
	var poolPieDiv = document.getElementById("poolPie");
	var allSystemPieDiv = document.getElementById("storagePie");
	var allPercentage = 0;
	if(poolAlocated==0 || poolTotal==0){
		allPercentage = 0;
	}else{
		var percent = (poolAlocated*20)/poolTotal;
		if(percent<1) allPercentage=-86;
		else{
			percent = Math.round(percent);
			allPercentage = 86*(percent+1);
			allPercentage=-allPercentage-1;
		}
	}
	poolPieDiv.style.backgroundPosition=allPercentage;
	
	allPercentage = 0;
	if(poolPhysical==0 || subSystemTotal==0){
		allPercentage = 0;
	}else{
		var percent = (poolPhysical*20)/subSystemTotal;
		if(percent<1) allPercentage=-86;
		else{
			percent = Math.round(percent);
			allPercentage = 86*(percent+1);
			allPercentage=-allPercentage-1;
		}
	}
	allSystemPieDiv.style.backgroundPosition=allPercentage;
}

function enablePoolProperties(thisObj){
	//document.getElementById(namespace_g + 'myForm:PoolName').disabled = false;
	var frame;
	for(var i=0;i<window.frames.length;i++){
		if(window.frames[i].name =="poolAdvance"){
			frame = window.frames[i];
		}
	}
	frame.document.getElementById(namespace_g + 'myForm:controllerMenu').disabled = false;
	document.getElementById(namespace_g + 'myForm:OkButton').style.display = "block";
	document.getElementById(namespace_g + 'myForm:cancelButton').style.display = "block";  
	document.getElementById(namespace_g + 'myForm:closeButton').style.display = "none";
	document.getElementById(namespace_g + 'myForm:editButton').style.display = "none";
	thisObj.disabled = true;
}

function poolModifyConfiramation(){
	var newPoolName = document.getElementById(namespace_g + 'myForm:PoolName').value;
	var frame;
	for(var i=0;i<window.frames.length;i++){
		if(window.frames[i].name =="poolAdvance"){
			frame = window.frames[i];
		}
	}
	var ipMenu = frame.document.getElementById(namespace_g + 'myForm:controllerMenu');
	document.getElementById(namespace_g + 'myForm:poolNameOutput').innerHTML=newPoolName;
	document.getElementById(namespace_g + 'myForm:ctrIp').innerHTML=ipMenu.options[ipMenu.options.selectedIndex].value;
 return true;
}
function doModifyPoolAction(){
	document.getElementById(namespace_g + 'myForm:propertiesUpdater').click();
}

function poolLocating(flag){
	document.getElementById(namespace_g + 'myForm:locating_starter').click();
	document.getElementById(namespace_g + "myForm:confirm_dialog_right").disabled = flag;
}
function closeConfirmDialog(clickEvent){
	var dialog = hX_5.getComponentById(namespace_g + "myForm:confirm_dialog");	
	if(dialog != null){
		dialog.redraw();
		if(clickEvent != null)
			dialog.hide(clickEvent)
	}			
}
function disablePoolConfirmButtons(flag){
	document.getElementById(namespace_g + "myForm:confirm_dialog_left").disabled = flag;
	document.getElementById(namespace_g + "myForm:confirm_dialog_right").disabled = flag;
}


function onLoad_PoolProperties(){
	parent.stopWait("util_dialog");
	if(hX_5.brw.isIE()){
		parent.document.getElementById('templ_u_iframe').contentWindow.document.getElementById('poolGeneralProperties').src=document.global_context_path + "/faces/page/rbce/storage/PoolGeneralProperties.jsp";
		parent.document.getElementById('templ_u_iframe').contentWindow.document.getElementById('poolVolume').src=document.global_context_path + "/faces/page/rbce/storage/PoolAssolatedVolumes.jsp";
		parent.document.getElementById('templ_u_iframe').contentWindow.document.getElementById('poolDisk').src=document.global_context_path + "/faces/page/rbce/storage/PoolRelatedDisks.jsp";
		//parent.document.getElementById('templ_u_iframe').contentWindow.document.getElementById('poolAdvance').src=document.global_context_path + "/faces/page/rbce/storage/PoolAdvanceProperties.jsp";
		
	}
	else{
		parent.document.getElementById('templ_u_iframe').contentDocument.getElementById('poolGeneralProperties').src=document.global_context_path + "/faces/page/rbce/storage/PoolGeneralProperties.jsp";
		parent.document.getElementById('templ_u_iframe').contentDocument.getElementById('poolVolume').src=document.global_context_path + "/faces/page/rbce/storage/PoolAssolatedVolumes.jsp";
		parent.document.getElementById('templ_u_iframe').contentDocument.getElementById('poolDisk').src=document.global_context_path + "/faces/page/rbce/storage/PoolRelatedDisks.jsp";
		//parent.document.getElementById('templ_u_iframe').contentDocument.getElementById('poolAdvance').src=document.global_context_path + "/faces/page/rbce/storage/PoolAdvanceProperties.jsp";
		
	}
	
	// initial error message	
	subTabCount = 3;
	initErrorMessage();
}

function StorageTabOnEnter(theObj,theEvent){
	var tabId = theEvent.tobeEnterPanel;
	var tableId = "";
	var frameId = ""
	if(tabId.endWith("volumesTab")){
		tableId = namespace_g + "myForm:volumesTable";
		frameId = "iframe1";
	}else if(tabId.endWith("poolsTab")){
		tableId = namespace_g + "myForm:storagePoolTable";
		frameId = "iframe2";
	}else if(tabId.endWith("disksTab")){
		tableId = namespace_g + "myForm:disksTable";
		frameId = "iframe4";
	}else if(tabId.endWith("configsTab")){
		tableId = namespace_g + "myForm:configs_table";
		frameId = "cfgFrame";
	}else if(tabId.endWith("poolDisksTab")){
		tableId = namespace_g + "myForm:storagePoolDiskTable";
		frameId = "poolDisk";
	}else if(tabId.endWith("poolVolumesTab")){
		tableId = namespace_g + "myForm:storagePoolTable";
		frameId = "poolVolume";
	}else if(tabId.endWith("volumeDisksTab")){
		tableId = namespace_g + "myForm:AssociatedDiskTable";
		frameId = "iframe3";
	}else if(tabId.endWith("hostsTab")){
		tableId = "hostMainTable";
		frameId = "hostIframe";
	}else if(tabId.endWith("volumeHostsTab")){
		tableId = "hostMainTable";
		frameId = "iframe2";
	}
	
	if(""!=tableId){
		var documentObj = null;
		if(document.getElementById(frameId).contentDocument){
			documentObj = document.getElementById(frameId).contentDocument;
		}else{
			documentObj = document.getElementById(frameId).contentWindow.document;
		}
		var LazyFunc = new LazyAdjustColumnWidth(documentObj,'headerTableDivId',tableId);
		LazyFunc.lazyRun();
	}
	return true;
}
function LazyAdjustColumnWidth(documentObj,headerTableDivId,contentTableId){
	var docObj = documentObj;
	var headerDivId = headerTableDivId;
	var tableId = contentTableId;
	
	this.lazyRun = function(){
		setTimeout(this.adjustColumnWidth,200);
	}
	this.adjustColumnWidth =function(){
		alignTabbedHeaderTableAndContentTable();			
	}
	function alignTabbedHeaderTableAndContentTable(){
			documentObj = (docObj)?docObj:document;
			var headerTableDivId = (headerDivId)?headerDivId:"headerTableDivId";
			var headerDiv = documentObj.getElementById(headerTableDivId);
			var bodyTable = documentObj.getElementById(tableId);
			if (headerDiv != null && bodyTable != null) {
				var divWidth = headerDiv.clientWidth;
				var bodyTableWidth = bodyTable.offsetWidth;
				var paddingRightWidth = 0;
				if (divWidth > bodyTableWidth) {
					//the body table has the scroll bar
					paddingRightWidth = divWidth - bodyTableWidth;
				}
				headerDiv.style.paddingRight = paddingRightWidth;
			}	
	}
}

function propertylink(){
	document.getElementById("property_link").onclick();
}
function setTarget(){
	document.getElementById(namespace_g + "myForm").target = "templ_u_iframe";
}

var selectedVolumeRelatedDiskNumber = 0;



function updateVolumePiePercentage(){
	var volumeTotal = document.getElementById(namespace_g + "myForm:volumeTotal").innerHTML;
	var poolTotal = document.getElementById(namespace_g + "myForm:poolTotal").innerHTML;

	var allPercentage = 0;

	if(volumeTotal==0 || poolTotal==0){
		allPercentage = 0;
	}else{
		var percent = (volumeTotal*20)/poolTotal;
		if(percent<1) allPercentage=-86;
		else{
			percent = Math.round(percent);
			allPercentage = 86*(percent+1);
			allPercentage=-allPercentage;
		}
	}
	var usagePieDiv = document.getElementById("usagePie");
	usagePieDiv.style.backgroundPosition=allPercentage-1;

}
function disableVolumeConfirmButtons(flag){
	document.getElementById(namespace_g + "myForm:confirm_dialog_left").disabled = flag;
	document.getElementById(namespace_g + "myForm:confirm_dialog_right").disabled = flag;
}
function volumeStartLocating(){
	document.getElementById(namespace_g + 'myForm:startingLocate').style.display="block";
	document.getElementById(namespace_g + 'myForm:stopingLocate').style.display="none";
}
function volumeStopLocating(){
	document.getElementById(namespace_g + 'myForm:startingLocate').style.display="none";
	document.getElementById(namespace_g + 'myForm:stopingLocate').style.display="block";
}
function selectVolumeDisk(thisObj){
	if(thisObj && thisObj.checked){
		selectedVolumeRelatedDiskNumber++;
	}else if(thisObj){
		selectedVolumeRelatedDiskNumber--;	
	}
	if(selectedVolumeRelatedDiskNumber>0){
		document.getElementById(namespace_g + 'myForm:LocateDriverBtn').disabled = false;
	}
	else {
		document.getElementById(namespace_g + 'myForm:LocateDriverBtn').disabled = true;
	}
	highlightStartRow(namespace_g + "myForm:AssociatedDiskTable");
}

function setVolumeFormTarget(thisObj,dialogName,width, height){
	if(dialogName == 'util_dialog'){
		if(document.getElementById('templ_waitDiv_utility').src!="")
			document.getElementById('templ_waitDiv_utility').src = "";
		
		thisObj.form.target="templ_u_iframe";
		
		document.getElementById(namespace_g + 'myForm:util_dialog_luncher').click();
		if(width == null){
			var width  = document.body.offsetWidth*0.70; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}
		if(height == null){
			var height  = window.outerHeight*0.70; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;		
		}
	}

	return true;
}

/**
 * Get the cache mode value and show the confirmation dialog
 *
 */
function doModifyCacheMode(){
    var radios = document.getElementsByName(namespace_g + "myForm:radio1");
    for( var i=0;i<radios.length;i++){
   	     if( radios[i].checked){
   	        document.getElementById(namespace_g + "myForm:writeCacheMode_value").value = radios[i].value;
   	   }
    }
   
    var cacheMode = document.getElementById(namespace_g + "myForm:writeCacheMode_value").value;   
   	if(cacheMode == '0'){
		parent.document.getElementById(parent.namespace_g + 'myForm:cacheReset').innerHTML = document.getElementById(namespace_g + 'myForm:RAIDAdvanced_Confirm_Enabled').innerHTML;
	}else{
		parent.document.getElementById(parent.namespace_g + 'myForm:cacheReset').innerHTML = document.getElementById(namespace_g + 'myForm:RAIDAdvanced_Confirm_Disabled').innerHTML;
	}	
    parent.document.getElementById(parent.namespace_g + 'myForm:confirm_Button').click();
}

/**
 * Submit the action of modifying the cache mode
 *
 */
function doOK_controller_Button(){
	var advanced_iframe = getFrame("volAdvance");
	advanced_iframe.document.getElementById(namespace_g + "myForm:modify_Button").disabled = true;
	advanced_iframe.document.getElementById(namespace_g + 'myForm:propertiesUpdater').click();
}

/**
 * Get the child iframe from parent iframe
 *
 */
function getFrame(iframeName){
    return eval("self." + iframeName); 
}

function disablePropertiesEditMode(){
    document.getElementById(namespace_g + 'myForm:OkButton').style.display = "none";
	document.getElementById(namespace_g + 'myForm:cancelButton').style.display = "none";
	document.getElementById(namespace_g + 'myForm:closeButton').style.display = "block";
	document.getElementById(namespace_g + 'myForm:editButton').disabled = false;
	document.getElementById(namespace_g + 'myForm:editButton').style.display = "block";
}

function volumeSubmitAction(thisObj){
	syncCheckbox(false, "rowLinkHidden");
	document.getElementById(namespace_g + "myForm:link_column_name_hidden").value = "";
	if(isSelectOptionDisabled(thisObj)) {
		return;
	}
	var action = thisObj.options[thisObj.options.selectedIndex].value;

	if(action == "Properties"){	    
		document.getElementById(namespace_g + 'myForm:viewProperties').click();
		parent.setStorageUtilTitle('volumePropertiesTitle');
	}
	if(action == "Delete"){
		document.getElementById(namespace_g + 'myForm:deleteVolsDialogPopup').click();
	}
	if(action == "Expand") {
		document.getElementById(namespace_g + 'myForm:expandVolume').click();
	}
	if(action == "UnmapHosts") {
		document.getElementById(namespace_g + 'myForm:UnmapHostHiddeBtn').click();
		parent.setStorageUtilTitle('volumePropertiesTitle');
	}
	thisObj.options[0].selected = true;
}


/**
 * 
 * Sync the specific checkboxs
 */
function syncCheckbox(isChecked, subId){	
	var allCheckBoxs = getElementsByTagNameAndType("input","checkbox");
	var checkBoxs = getCheckboxBySubID(allCheckBoxs, subId);
	
	for(var i=0; i<checkBoxs.length; i++) {
		var boxObj = checkBoxs[i];
		boxObj.checked = isChecked;
	}
}

/**
 * Get the checkbox list by the subID
 *
 */
function getCheckboxBySubID(checkBoxs, subId){
	var displayBoxs = new Array();
	var index = 0;
	for(var i=0; i<checkBoxs.length; i++) {
		var boxObj = checkBoxs[i];
		var boxId = boxObj.id;
		if(boxId != null && boxId.indexOf(subId) > -1) {
			displayBoxs[index] = boxObj;
			index++;
		}
	}
	return displayBoxs;
}

/**
 * Function for clicking the status link in the storage tabs
 *
 */

String.prototype.trim = function () {
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
}

function initDeleteTable(){
    rowCount = 0;
	var ary = getSelectedObject(namespace_g + "myForm:volumesTable");
	clearTable();
        for(var j=0;j<ary.length;j++){
		  var tableObj =document.getElementById('deleteVolumeTable_tableHeader');
		  var x = tableObj.getElementsByTagName("tbody")[0].insertRow(rowCount++);
		      x.align="left";
			  var y=x.insertCell(0);
			  var z=x.insertCell(1);
			  var k=x.insertCell(2);
			  y.innerHTML=removeNbsp(ary[j].name);
			  y.width="42%";
			  z.innerHTML=ary[j].cap;
			  z.width="31%";
			  k.innerHTML=removeNbsp(ary[j].host);
			  k.width="27%";
			  y.className="dmc_outputText";
			  z.className="dmc_outputText";
			  k.className="dmc_outputText";
			  x.className=(rowCount%2==0)?"dmc_rowClass2":"dmc_rowClass1";
		  }
	// enable the button		  
	document.getElementById(namespace_g + 'myForm:confirm_dialog_left').disabled = false;
	document.getElementById(namespace_g + 'myForm:confirm_dialog_right').disabled = false;
	hideProgressIndicator('spinningDiv');
	
	//judge if can display the warning message
	var hasMappedHost=false;
    for(var i=0;i<ary.length;i++){
		if(ary[i].isVolumeMapped=='true'){
			hasMappedHost=true;
			break;
		}
		else {
			continue;
		}
	}
	document.getElementById("volConfirmDeleteWarningTr").style.display="none";
	document.getElementById(namespace_g + "myForm:confirm_dialog_vols").style.height="275px";
	if(hasMappedHost){
		document.getElementById("volConfirmDeleteWarningTr").style.display="";
		document.getElementById(namespace_g + "myForm:confirm_dialog_vols").style.height="290px";
	}
	alignHeaderTableAndContentTable('delVolheaderTableDivId','deleteVolumeTable_tableHeader');
		  
}

function clearTable(){
  var x=document.getElementById('deleteVolumeTable_tableHeader');
  var tbodyObj = x.getElementsByTagName("tbody")[0]
  for(var i=tbodyObj.rows.length-1;i>=0;i--){
  	tbodyObj.deleteRow(i);
  }
}

function VolumeObject(name,cap,host,isMapped){
 this.name = name;
 this.cap = cap;
 this.host = host;
 this.isVolumeMapped = isMapped;
}

function getSelectedObject(tableId) {
    var selectedObject = new Array();
	var elmt = document.getElementById(tableId);
	var tbody = elmt.getElementsByTagName("tbody");
	trs = tbody[0].rows;
	for(var i=0;i<trs.length;i++){
	  var node = trs[i];
	  while(node){
		 node = node.childNodes[0];	
		 if(node.tagName)
		    if(node.tagName=="INPUT")
		    	break;
	  }
	  if(node.tagName=="INPUT" && node.checked){
	  	 var cells = trs[i].cells;
	  	 selectedObject.push(new VolumeObject(cells[1].firstChild.lastChild.innerHTML,cells[3].firstChild.lastChild.innerHTML,cells[6].firstChild.lastChild.previousSibling.innerHTML,cells[6].firstChild.lastChild.innerHTML));	  	 
	  }
	}
	return selectedObject;
}

function highlightStartRow(tableId)
{
	var elmt = document.getElementById(tableId);
	if(elmt==null)
		return;
	var tbody = elmt.getElementsByTagName("tbody");
	if(tbody==null || tbody.length==0)
		return;
	trs = tbody[0].getElementsByTagName("tr");
	for(var i=0;i<trs.length;i++){
	  var node = trs[i];
	  while(node){
		 node = node.childNodes[0];	
		 if(node)
			 if(node.tagName)
			    if(node.tagName=="INPUT")
			    	break;
	  }
	  if(node){
		  if(node.tagName=="INPUT" && node.checked)
				trs[i].className="dmc_rowHightLightClass";
		  else{
			  if(i%2==0)
			    trs[i].className="dmc_rowClass1";
			   else
			    trs[i].className="dmc_rowClass2";    
			}
		}
	}
}

function onLoad_Storage(){
	disableRefreshButton(true);
	initCounter(5, REFRESH_MASK_VOLUME+REFRESH_MASK_POOL+REFRESH_MASK_HOST+REFRESH_MASK_DISK+REFRESH_MASK_CONFIGURATION);
	
	document.getElementById("iframe1").src=current_context + "/faces/page/rbce/storage/VolumesTab.jsp";
	setTimeout(startOther4Tabs , 1000);
	initErrorMessage();
}

function startOther4Tabs() {
	document.getElementById("iframe2").src=current_context + "/faces/page/rbce/storage/PoolsTab.jsp";
	document.getElementById("hostIframe").src=current_context + "/faces/page/rbce/storage/HostsTab.jsp";
	document.getElementById("iframe4").src=current_context + "/faces/page/rbce/storage/DisksTab.jsp";	
	document.getElementById("cfgFrame").src=current_context + "/faces/page/rbce/storage/ConfigModel.jsp";
}

function onLoad_VolumePropertyTabs() {
	parent.stopWait("util_dialog");
	document.getElementById('iframe1').src=document.global_context_path + "/faces/page/rbce/storage/VolumesGeneral.jsp";
	document.getElementById("iframe2").src=document.global_context_path + "/faces/page/rbce/storage/MappedHosts.jsp";
	document.getElementById("iframe3").src=document.global_context_path + "/faces/page/rbce/storage/AssociatedDisk.jsp";
	//document.getElementById("iframe4").src=document.global_context_path + "/faces/page/rbce/storage/VolumesAdvanced.jsp";
	
	// initial error message
	subTabCount = 3;
	initErrorMessage();
}

function changeStroageDeviceList(thisform){
	document.getElementById(namespace_g + "myForm:selectedTabName").value=eval(ns + 'ODCTabPanelControlVar1').selectedTabID;
	thisform.target = "";
	thisform.submit();
}

var PORTS_NUM = 2;
var selectedHostArray = new Array();
function highLightingHosts(theObj,groupid){
	var rowClass = "dmc_rowClass1";
	if(theObj.checked){
	  	rowClass ="dmc_rowHightLightClass";
	  	selectedHostArray.push(groupid);
	  }else{
	  	removeGroupId(groupid);
	  }
	  	var stable = document.getElementById(groupid);
				stable.rows[1].className=rowClass;
		  	 	for(var j=0;j<PORTS_NUM;j++){ 
		  	 		var pt = document.getElementById(groupid+"_"+j);
		  	 		  if(pt){
						pt.rows[1].className=rowClass;
		  	 		  }
		  	 	}
		volumeRelatedHostChecked(theObj);
}

var selectedHosts = 0;
function volumeRelatedHostChecked(theObj){
	if(theObj.checked){
		selectedHosts++;
	 }else{
		 selectedHosts-- ;
	 }
	 var parentPoolDismounted = document.getElementById(namespace_g + "myForm:parentPoolDismounted").innerHTML;
	 if(selectedHosts>0 && parentPoolDismounted!="true"){
	 	document.getElementById(namespace_g + "myForm:treeTable:unmapHostBtn").disabled = false;
	 }else{
	 	document.getElementById(namespace_g + "myForm:treeTable:unmapHostBtn").disabled = true;	 
	 }
}

function removeGroupId(groupid){
	for(var i=0;i<selectedHostArray.length;i++){
		if(selectedHostArray[i]==groupid){
			selectedHostArray.splice(i,1);
			break;
		}
	}
}

function enableUnmapBtn(){
	var editmode = parent.document.getElementById(parent.namespace_g + 'myForm:editMode').innerHTML;
	if(editmode == "true"){
		if(selectedHostArray.length != "0" && document.getElementById(namespace_g + 'myForm:treeTable:unmapHostBtn')){
			document.getElementById(namespace_g + 'myForm:treeTable:unmapHostBtn').disabled = false;
		}else if(document.getElementById(namespace_g + 'myForm:treeTable:unmapHostBtn')){
			document.getElementById(namespace_g + 'myForm:treeTable:unmapHostBtn').disabled = true;
		}
	}
}

function unmapHostBtnClick(){
	parent.document.getElementById(parent.namespace_g + 'myForm:host_Unmapped').innerHTML = "true";
	document.getElementById(namespace_g + 'myForm:unmapHostSubmitBtn').click();
}

function refreshAfterModifyVolume(){
	/*var poolWindow;
	if(parent.document.getElementById('iframe2').contentDocument){
		poolWindow = parent.document.getElementById('iframe2').contentDocument;
		poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
	}else{
		poolWindow = parent.document.getElementById('iframe2').contentWindow;
		poolWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
	}
	
	var hostWindow;
	if(parent.document.getElementById('hostIframe').contentDocument){
		hostWindow = parent.document.getElementById('hostIframe').contentDocument;
		hostWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/HostsTab.jsp";
	}else{
		hostWindow = parent.document.getElementById('hostIframe').contentWindow;
		hostWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
	}*/
	parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_HOST);
}

function closeVolumePropertyModal(){
	parent.closeUtilDialog();
	var needrefresh = document.getElementById(namespace_g + 'myForm:host_Unmapped').innerHTML;
	if(needrefresh == "true"){
		/*var hostWindow;
		if(parent.document.getElementById('hostIframe').contentDocument){
			hostWindow = parent.document.getElementById('hostIframe').contentDocument;
			hostWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/HostsTab.jsp";
		}else{
			hostWindow = parent.document.getElementById('hostIframe').contentWindow;
			hostWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
		}
		var volumeWindow;
		if(parent.document.getElementById('iframe1').contentDocument){
			volumeWindow = parent.document.getElementById('iframe1').contentDocument;
			volumeWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/VolumesTab.jsp";
		}else{
			volumeWindow = parent.document.getElementById('iframe1').contentWindow;
			volumeWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
		}*/
		parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_HOST);	
	}
}

function onLoad_DiskDriveProperties(){
	// Call the common function to start the ajax request
	commonPageLoad();
	
	parent.stopWait("util_dialog");
}

function onLoad_DiskAssignDedicated(){
	// Call the common function to send the ajax request
	commonPageLoad();
	
	parent.stopWait("util_dialog");	
}

function onLoad_PoolAssignDedicated(){
	// Call the common function to send the ajax request
	commonPageLoad();
	
	parent.stopWait("util_dialog");
	document.getElementById(namespace_g + "myForm:poolAssignDedicatedOK").disabled = true;
}

function onLoad_PoolUnassignDedicated(){
	// Call the common function to send the ajax request
	commonPageLoad();
	
	parent.stopWait("util_dialog");
}

function onLoad_MappedHosts() {
	// Call the common function to send the ajax request
	commonPageLoad();

	parent.stopWait("util_dialog");
}


function lazyDo() {
	var clickbtn = document.getElementById(namespace_g + "myForm:clickbtn");
	if (clickbtn) {
		clickbtn.click();
	}
}

var selectedAvailableDisks = 0;

function updateAssignDedicatedOK(thisObj){
	if(thisObj && thisObj.checked){
		selectedAvailableDisks++;

	}else if(thisObj){
		selectedAvailableDisks--;	
	}
	
	if(selectedAvailableDisks > 0) {
		 document.getElementById(namespace_g + "myForm:poolAssignDedicatedOK").disabled = false;	 
	} else {
		document.getElementById(namespace_g + "myForm:poolAssignDedicatedOK").disabled = true;
	}
}

var selectedDedicatedDisks = 0;
function updateUnassignDedicateOK(thisObj){
	if(thisObj && thisObj.checked){
		selectedDedicatedDisks++;

	}else if(thisObj){
		selectedDedicatedDisks--;	
	}
	
	if(selectedDedicatedDisks > 0) {
		 document.getElementById(namespace_g + "myForm:poolUnassignDedicatedOK").disabled = false;	 
	} else {
		document.getElementById(namespace_g + "myForm:poolUnassignDedicatedOK").disabled = true;
	}
}


function setDiskFormTarget(thisObj,dialogName,width, height){
		if(dialogName == 'util_dialog'){
		if(document.getElementById('templ_waitDiv_utility').src!="")
			document.getElementById('templ_waitDiv_utility').src = "";
		
		
		thisObj.form.target="templ_u_iframe";
		
		if(width == null){	
			width  = document.body.offsetWidth*0.80; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}
		if(height == null){
			if(hX_5.brw.isIE())
				height  =document.body.offsetHeight*0.85;
			else
				height  = window.outerHeight*0.85; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;		
		}
	}
	document.getElementById(namespace_g + 'myForm:util_dialog_luncher').click();
		
	return true;
}


/*function refreshPoolsTab(){
	if(document.getElementById(namespace_g + "myForm:refreshPools").innerHTML=="true"){
		document.getElementById(namespace_g + "myForm:refreshPools").innerHTML = "false";
		var poolWindow;
		if(parent.document.getElementById('iframe2').contentDocument){
			poolWindow = parent.document.getElementById('iframe2').contentDocument;
			poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
		}else{
			poolWindow = parent.document.getElementById('iframe2').contentWindow;
			poolWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
		}		
	}
}*/

function completePoolDeleteAction(){
		var volumeWindow;
		if(parent.document.getElementById('iframe1').contentDocument){
			volumeWindow = parent.document.getElementById('iframe1').contentDocument;
		}else{
			volumeWindow = parent.document.getElementById('iframe1').contentWindow;
		}
		volumeWindow.location.reload();	
}

function setCtgTarget(thisObj,width,height){
		
		if(document.getElementById('templ_waitDiv_utility').src!="")
			document.getElementById('templ_waitDiv_utility').src = "";
		
		thisObj.form.target="templ_u_iframe";
		
		document.getElementById(namespace_g + 'myForm:util_dialog_luncher').click();
		if(width == null){
			var width  = document.body.offsetWidth*0.70; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
		}
		if(height == null){
			var height  = window.outerHeight*0.70; //set a better pop-up width 
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;
		}else{
			document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;		
		}
}

function setCfgFormTarget(thisObj,dialogName,width, height, thisEvent){
	var ret = true;
	var cfgiFrame = parent.getFrame("cfgFrame");
	if(dialogName == 'config_backup'){
		setFormTargetFromStorage(width,height);
	}else if(dialogName == 'config_restore'){
//		var cfgFileNum = cfgiFrame.document.getElementById(namespace_g + "myForm:cfgFileNum").innerHTML;
//	    if(null==cfgFileNum||0>=cfgFileNum-0){
//	       	cfgiFrame.launchModal(namespace_g + "myForm:cantRestore_dialog" ,thisEvent);
//	        ret = false;
//	    }else{
			setFormTargetFromStorage(width,height);
//		}
	}else if(dialogName == 'config_save'){
		var currentExist = cfgiFrame.document.getElementById(namespace_g + "myForm:currentExist").innerHTML;
		if( currentExist == 'false'){	  	        
	        cfgiFrame.launchModal(namespace_g + "myForm:saveAsExist_dialog" ,thisEvent);
	        ret = false;	 
	    }
	    else{	    
	    	setFormTargetFromStorage(width,height);
	    } 
	}else if(dialogName == 'config_download'){
		var cfgFileNum = cfgiFrame.document.getElementById(namespace_g + "myForm:cfgFileNum").innerHTML;
	    if(null==cfgFileNum||0>=cfgFileNum-0){
	        cfgiFrame.launchModal(namespace_g + "myForm:cantRestore_dialog" ,thisEvent);
	        ret = false;
	    }else{
			setFormTargetFromStorage(width,height);
		}
	}

	return true;
}

function launchModal(name,thisEvent){
    var modal = document.getElementById(name);
    
    if(name ==namespace_g + "myForm:dialogApply" || name ==namespace_g + "myForm:saveAsExist_dialog"){
        modal.style.width = "500px";
        modal.style.heigh = "400px";          
    } else if(name ==namespace_g + "myForm:restoreconfirm_dialog" || name==namespace_g + "myForm:saveconfirm_dialog" || name==namespace_g + "myForm:backupconfirm_dialog"){                        
        modal.style.width = "500px";
        modal.style.heigh = "350px";          
    } else if(name ==namespace_g + "myForm:backup_dialog" || name ==namespace_g + "myForm:save_dialog"){
    }                    
    var dialog = hX_5.getComponentById(name);
    dialog.show(thisEvent);		
}

function closeDialog(thisEvent, dialogName, newURL){
	var dialog = document.getElementById(namespace_g + "myForm:" + dialogName);
	var iframeobj = document.getElementById("backup_iframe");
	var divobj = document.getElementById("waitDiv_backup");
	if( dialog != null) {
		divobj.style.display = "none";
		iframeobj.src = "";
		dialog.style.visibility = "hidden";
	}
	return true;				
}

//clear the iframe src when closing the pannelDialog
function clearFrame(dialogName){
	var iframeObj;
	var iframeDIVObj;
	if(dialogName == "cfgAction_dialog"){
		if( document.getElementById('cfgAction_iframe')){
			iframeObj = document.getElementById("cfgAction_iframe");
		   	iframeDIVObj = document.getElementById("waitDiv_cfgAction");
		}else if( parent.document.getElementById('cfgAction_iframe')){
		   	iframeObj = parent.document.getElementById("cfgAction_iframe");
		   	iframeDIVObj = parent.document.getElementById("waitDiv_cfgAction");
		}
	}
	if( iframeObj.src != ''){
		iframeObj.src = '';	
		iframeDIVObj.style.visibility= "hidden";	
	}					
}

function onLoad_SaveConfiguration(){
	parent.stopWait("util_dialog");
	var closesyb = document.getElementById(namespace_g + "myForm:dialog_close_txt").innerHTML;
	if(closesyb == 'yes'){
		document.getElementById(namespace_g + "myForm:close_save_btn").click();
		return;
	}
	initDisableRadio();
	// initial error message	
	initErrorMessage();	
	document.getElementById(namespace_g + "myForm:save_OkBtn").disabled = false;	
	document.getElementById(namespace_g + "myForm:save_CancelBtn").disabled = false;
	alignHeaderTableAndContentTable('headerTableDivId','configs_table');
}


/*function reloadConfigTab(){
		var configWindow;
		if(parent.document.getElementById('cfgFrame').contentDocument){
			configWindow = parent.document.getElementById('cfgFrame').contentDocument;
			configWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/ConfigModel.jsp";
		}else{
			configWindow = parent.document.getElementById('cfgFrame').contentWindow;
			configWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
		}
}*/
function onLoad_BackupConfiguration(){	
	parent.stopWait("util_dialog");
	var closesyb = document.getElementById(namespace_g + "myForm:dialog_close_txt").innerHTML;
	if(closesyb == 'yes'){
		document.getElementById(namespace_g + "myForm:close_backup_btn").click();
		return;
	}
	
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_RestoreConfiguration(){
	parent.stopWait("util_dialog");
	var closesyb = document.getElementById(namespace_g + "myForm:dialog_close_txt").innerHTML;
	if(closesyb == 'yes'){
		document.getElementById(namespace_g + "myForm:close_restore_btn").click();
		return;
	}
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_DownLoadConfiguration(){
	parent.stopWait("util_dialog");	
	
	// Call the common function to send the ajax request
	commonPageLoad();	
}

function disableButton(dialogname){	 
	if(dialogname == 'save_dialog'){   
	   document.getElementById(namespace_g + "myForm:confirm_save_OkBtn_button").disabled = true;	  	   
	   document.getElementById(namespace_g + "myForm:confirm_save_CancelBtn").disabled = true;		
	   document.getElementById(namespace_g + "myForm:confirm_save_OkBtn").click();	
	}
	else if(dialogname == 'backup_dialog'){	
	   document.getElementById(namespace_g + "myForm:confirm_backup_OkBtn_button").disabled = true;	  	   
	   document.getElementById(namespace_g + "myForm:confirm_backup_CancelBtn").disabled = true;
	   document.getElementById(namespace_g + "myForm:confirm_backup_OkBtn").click();	
	}
	else if(dialogname == 'restore_dialog'){
	   document.getElementById(namespace_g + "myForm:confirm_restore_OkBtn_button").disabled = true;	  	   
	   document.getElementById(namespace_g + "myForm:confirm_restore_CancelBtn").disabled = true;	
	    var servoperates = document.getElementsByName("servoperate");
		var servoperate = "";
		for(var i=0;i<servoperates.length;i++){
			if(servoperates[i].checked){
				servoperate = servoperates[i].value;
				break;
			}
		}
		
		if (servoperate == "remote") {
	   document.getElementById(namespace_g + "myForm:confirm_restore_OkBtn").click();	
		} else {
			document.getElementById(namespace_g + "myForm:restore_download_btn").click();
		}
	   
	} else if(dialogname == 'poolAssignDedicated') {
		document.getElementById("assignDedicatedSpareDiskDrive").style.visibility= "visible";	
		
		document.getElementById(namespace_g + "myForm:poolAssignDedicatedOK").disabled = true;	  	   
	    document.getElementById(namespace_g + "myForm:poolAssignDedicatedCancel").disabled = true;	
	    var i=0;
	    while(true){
	    	var dispCheckbox = document.getElementById(namespace_g + "myForm:disksTable:"+i+":dispCheckBox");
	    	if(null!=dispCheckbox){
	    		dispCheckbox.disabled = true;
	    		i++;
	    	}
	    	else{
	    		break;
	    	}
	    }	
	} else if(dialogname == 'poolAssignGlobal') {
		//document.getElementById("assignGlobalSpareDiskDrive").style.visibility= "visible";
		
		document.getElementById(namespace_g + "myForm:poolAssignGlobalOK").disabled = true;	  	   
	    document.getElementById(namespace_g + "myForm:poolAssignGlobalCancel").disabled = true;
	    var i=0;
	    while(true){
	    	var dispCheckbox = document.getElementById(namespace_g + "myForm:disksTable:"+i+":dispCheckBox");
	    	if(null!=dispCheckbox){
	    		dispCheckbox.disabled = true;
	    		i++;
	    	}
	    	else{
	    		break;
	    	}
	    }
	} else if(dialogname == 'diskAssignGlobal') {
		//document.getElementById("assignGlobalSpareDiskDrive").style.visibility= "visible";
		//defect 6901,change css property visibility->display for visiblity always occupy places. by qiuhongyan
		
		//document.getElementById("assignGlobalSpareDiskDrive").style.display="";
		
		document.getElementById(namespace_g + "myForm:confirm_dialog_left").disabled = true;	  	   
	    document.getElementById(namespace_g + "myForm:confirmGlobalSpare_dialog_right").disabled = true;	
	    document.getElementById(namespace_g + "myForm:confirm_dialog_left_hidden").click();	
	} else if(dialogname == 'poolUnassignDedicated'){
		document.getElementById("unassignDedicatedSpareDiskDrive").style.visibility= "visible";
		
		document.getElementById(namespace_g + "myForm:poolUnassignDedicatedOK").disabled = true;	  	   
	    document.getElementById(namespace_g + "myForm:poolUnassignDedicatedCancel").disabled = true;	
	    var i=0;
	    while(true){
	    	var dispCheckbox = document.getElementById(namespace_g + "myForm:disksTable:"+i+":dispCheckBox");
	    	if(null!=dispCheckbox){
	    		dispCheckbox.disabled = true;
	    		i++;
	    	}
	    	else{
	    		break;
	    	}
	    }
	} else if( dialogname == 'warning_unassignGlobal'){
	    document.getElementById(namespace_g + 'myForm:unassignSpare_hidden').click();
	    showProgressIndicator('spinningDiv_warning_unassignGlobal');
	  	document.getElementById(namespace_g + 'myForm:confirm_unassignGlobal_dialog_left').disabled = true;
	    document.getElementById(namespace_g + 'myForm:warning_unassignGlobal_close').disabled = true;	   
	}
	
	return true;	
}

function resetButton(dialogname){	 
	if(dialogname == 'save_dialog'){
	   document.getElementById(namespace_g + "myForm:save_OkBtn").disabled = false;	  	   
	   document.getElementById(namespace_g + "myForm:save_CancelBtn").disabled = false;		
	}
	else if(dialogname == 'backup_dialog'){
	   document.getElementById(namespace_g + "myForm:backup_OkBtn").disabled = false;	  	   
	   document.getElementById(namespace_g + "myForm:backup_CancelBtn").disabled = false;		
	}
	else if(dialogname == 'restore_dialog'){
	   document.getElementById(namespace_g + "myForm:restore_OkBtn").disabled = false;	  	   
	   document.getElementById(namespace_g + "myForm:restore_CancelBtn").disabled = false;		
	}	
}

// set form target to a ralative 'top'
function setFormTarget2Top(submitForm){
	submitForm.target="cfgFrame";
}

function doOperate(id, action){		
   
   var cfgiFrame = parent.getFrame("cfgFrame");
   var number = document.getElementById(namespace_g + "myForm:cfgNumber").innerHTML;	
          
   if( action == 'backup'){
   	   number = document.getElementById(namespace_g + "myForm:backup_number").value;
   	}   
   	  
   if( action == 'restore_device'){
   	   number = document.getElementById(namespace_g + "myForm:restore_device_number").value;
   	}     
   var tableDataRadios = document.getElementsByName("selected");	 
   if( id == 'replace'){ 
       var i=0;
   	   if( action == 'backup'){ 	     
   	   	   i=1 ;
	   }
	   for( ; i < number; i++){										
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = false;
	   }
	   	   	     	   
	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = true; 
	   //init select the first one of the check box
	   if( action == 'save'){
           onSaveConfigRadioClick(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	  	   
   	   }
   	   
	   if(document.getElementById(namespace_g + "myForm:save_OkBtn")){
	       document.getElementById(namespace_g + "myForm:save_OkBtn").disabled = false; 	      
			document.getElementById("fileNameMsg").style.display = "none";					  
			document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";	
		}				  
	   
   }    
   if( id == 'create'){
   	   for( var i=0; i< number; i++){							
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = true;	
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").checked = false;
	   }
	   
	   if(tableDataRadios != null){
	   		for(var i = 0; i < tableDataRadios.length; i++){
	   			tableDataRadios[i].checked = false;
	   		}
	   }
	   var nickNameField = document.getElementById(namespace_g + "myForm:new_nickname");
   	   var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
	   nickNameField.disabled = false;
   }
	//radio behavior like checkbox,add by qiuhongyan
	if(tableDataRadios != null){
	    for(var i = 0; i < tableDataRadios.length; i++){
	        tableDataRadios[i].disabled = tableDataRadios[i].nextSibling.disabled;
	        tableDataRadios[i].checked = tableDataRadios[i].nextSibling.checked;
	    }
	}    
   document.getElementById("operate").value = id;	
}

function doBackupOperate(id, action){
   var cfgiFrame = parent.getFrame("cfgFrame");
   if( action == 'backup'){
     	// Defect 8442 adjust dialog size to initial size
   	   if (backupDialogHeightAdded) {
	   	    var originHeight = getOriginalDialogHeight();
	   		adjustDialogSizeForValidationMessage(650, originHeight - 20 - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
			backupDialogHeightAdded = false;
	   }
   	   number = document.getElementById(namespace_g + "myForm:backup_number").value;
   	}   
   	  
   if( action == 'restore_device'){
   		// Defect 8442 adjust dialog size to initial size
	   if (restoreDialogHeightAdded) {
	   		var originHeight = getOriginalDialogHeight();
	   		adjustDialogSizeForValidationMessage(710, originHeight - 20 - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
			restoreDialogHeightAdded = false;
	   }
   	   number = document.getElementById(namespace_g + "myForm:restore_device_number").value;
   	}     
   var servDataRadios = document.getElementsByName("selected"); 
   if( id == 'replace'){ 
       var i=0;
   	   if( action == 'backup'){ 	     
   	   	   i=1 ;
	   }
	   for( ; i < number; i++){										
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = false;
	   }
	   //init select the first one
	   if(servDataRadios != null && servDataRadios.length > 1){
	   	   if( action == 'restore_device'){
	   			servDataRadios[0].nextSibling.click();
		   }else{
		   		servDataRadios[1].nextSibling.click();
		   }	   	   
	   }   	     	   
	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = true; 
	   
	   if( action == 'save'){
           onSaveConfigRadioClick(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	  	   
   	   }
   	   	  if(document.getElementById(namespace_g + "myForm:restore_OkBtn")){
	       document.getElementById(namespace_g + "myForm:restore_OkBtn").disabled = false; 	      
					document.getElementById("fileNameMsg").style.display = "none";					  
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";	
			}				  
   	   	  if(document.getElementById(namespace_g + "myForm:backup_OkBtn")){
		       document.getElementById(namespace_g + "myForm:backup_OkBtn").disabled = false; 	      
					document.getElementById("fileNameMsg").style.display = "none";					  
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";	
			}				  
   	   
   }    
   if( id == 'create'){
   	   for( var i=0; i< number; i++){							
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = true;	
			//add by qiuhongyan,uncheck previous selected
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").checked = false;	
	   }

	   var newNickName = document.getElementById(namespace_g + "myForm:new_nickname");
   		var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
	   newNickName.disabled = false;
   }
   //radio behavior like checkbox,add by qiuhongyan
   if(servDataRadios != null){
	    for(var i = 0; i < servDataRadios.length; i++){
	        servDataRadios[i].disabled = servDataRadios[i].nextSibling.disabled;
	        servDataRadios[i].checked = servDataRadios[i].nextSibling.checked;
	    }
   }     
   document.getElementById("operate").value = id;	
}

function onSaveConfigRadioClick(thisObj, thisEvent){
	
	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
           
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("rowSelect1")-1));
     
    document.getElementById(namespace_g + "myForm:indexInput").innerHTML = selectedCheckBoxIndex-0+1;
        
	document.getElementById(namespace_g + "myForm:tosaveNickName").value = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output").innerHTML;						  			  			    
    //document.getElementById(namespace_g + "myForm:tosaveDescription").value = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":desc_output").innerHTML;
    var cfgiFrame = parent.getFrame("cfgFrame");
    var configNumber = document.getElementById(namespace_g + "myForm:cfgNumber").innerHTML;
		
    for(var i=0; i < configNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
				  
				document.getElementById(namespace_g + "myForm:indexInput").innerHTML = i-0+1;				  				  
				nickname = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output");		
				//description = document.getElementById(namespace_g + "myForm:configs_table:"+i+":desc_output");						
			    document.getElementById(namespace_g + "myForm:tosaveNickName").value = nickname.innerHTML;			        
			    //document.getElementById(namespace_g + "myForm:tosaveDescription").value = description.innerHTML;
		    
			}else{
				curr_row.checked=false;
			}	
		}
	}	  
}

// initialize the Replace and SaveAs Radio in SaveConfiguration Page
function initDisableRadio() { 

     var radios = null; 
     var tableRadios = null;
     var configNumber = document.getElementById(namespace_g + "myForm:cfgNumber").innerHTML; 

     var radiolabel1  = document.getElementById("radiolabel1");
     var radiolabel2  = document.getElementById("radiolabel2");  
     
     radiolabel1.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText1").innerHTML;
     radiolabel2.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText2").innerHTML; 
     
     cleanPanelComponent('save_dialog');
     
     var browser=navigator.appName;
	 if(browser=="Microsoft Internet Explorer"){		
		radios = document.all("operate");
	 }		  		
	 else{
	    radios = document.getElementsByName("operate");
	 }		 

	 if( radios != null)
	 {
		if( browser=="Microsoft Internet Explorer"){								
			if( configNumber == 0 ) {			
    			radios.item(0).disabled = true;
	    		radios.item(1).disabled = false;
	    		radios.item(1).click();
	    	}
	    	else {
	    		radios.item(0).disabled = false;	        	
	        	radios.item(1).disabled = false;  
	        	radios.item(0).click();
	        	tableRadios = document.all("selected");
				tableRadios.item(0).click(); 
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;	   	 	    
	   	 	}					
		 }
		else{	   		     				  
			if( configNumber == 0 ) {         
	    		radios[0].disabled = true;
	    		radios[1].disabled = false;
	    		radios[1].click();
	    	} else {
	    	    radios[0].disabled = false;	        	
	        	radios[1].disabled = false;
      			radios[0].click();
      			tableRadios = document.getElementsByName("selected");
      			tableRadios[0].click();  	
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;
	    	}   	
		}
	 }

	 document.getElementById(namespace_g + 'myForm:backupcheckBox').checked=true;	   
}

function cleanPanelComponent(dialogname){
 	if( dialogname == 'save_dialog'){   
        document.getElementById(namespace_g + "myForm:replace_nickname_value").value = '';        
    	document.getElementById(namespace_g + "myForm:new_nickname").value = '';
 	}
 	else if(dialogname == 'backup_dialog'){
     	document.getElementById(namespace_g + "myForm:backup_target_nickname").value = '';       
    	document.getElementById(namespace_g + "myForm:selected_backup_config").value = '';   
    	document.getElementById(namespace_g + "myForm:new_nickname").value = ''; 
 	}
 	else if(dialogname == 'restore_dialog'){
    	document.getElementById(namespace_g + "myForm:restore_server_name").value = '';       
    	document.getElementById(namespace_g + "myForm:restore_device_name").value = '';  
 	}
}

var maxConfig = 12;

function applayOkBtn(thisObj, thisEvent){
//	document.getElementById(namespace_g + "myForm:apply_OkBtn_submit").click();
	document.getElementById(namespace_g + "myForm:apply_OkBtn").disabled = true;
	document.getElementById(namespace_g + "myForm:apply_CancelBtn").disabled = true;
}

var saveDialogHeightAdded = false;
function saveOkBtn(thisObj, thisEvent){
 	var originHeight = getOriginalDialogHeight();   
	var operate  = document.getElementById("operate").value;

	var cfgiFrame = parent.getFrame("cfgFrame");
	var configNumber = document.getElementById(namespace_g + "myForm:cfgNumber").innerHTML; 
	var allCfgNumber = document.getElementById(namespace_g + "myForm:allCfgNumber").innerHTML; 
  	var choose_nickname = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_nickname").innerHTML; 
	var choose_description = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_description").innerHTML; 
	
	document.getElementById(namespace_g + 'myForm:ConfigModel_saveconfigShow').innerHTML = "";	
	document.getElementById(namespace_g + "myForm:confirm_save_OkBtn_button").disabled = false;	  	   
	document.getElementById(namespace_g + "myForm:confirm_save_CancelBtn").disabled = false;
	
		
  	var existed = false;
  	if( operate == 'create'){   
 
  		var save_new_nickname = document.getElementById(namespace_g + "myForm:new_nickname").value; 
	
	   var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
		if(!isDeviceNameValid(save_new_nickname) || allCfgNames.indexOf(","+save_new_nickname+",")>=0 || save_new_nickname.indexOf(CONNED_CFG_NAME_PREFIX)==0){
				document.getElementById("fileNameMsg").style.display = ""; 
				document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "";					  
				// Defect 8442 adjust dialog size for validation message
				if(!saveDialogHeightAdded){
					adjustDialogSizeForValidationMessage(700,originHeight - 0 + 20);		
					saveDialogHeightAdded = true;
				}
				document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
						  
				return ;
		}else{
				document.getElementById("fileNameMsg").style.display = "none"; 
				document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";
				// Wang Yuan' change for 6422
				document.getElementById(namespace_g + "myForm:save_CancelBtn").disabled = true;   					  		
		}
		if(allCfgNumber >= maxConfig) {
			document.getElementById(namespace_g + 'myForm:tosaveNickName').value = save_new_nickname;

		    document.getElementById(namespace_g + 'myForm:ConfigModel_saveconfigShow').innerHTML = 
			document.getElementById(namespace_g + 'myForm:ConfigModel_saveconfigTxt3').innerHTML + '<BR><BR>' + 
			document.getElementById(namespace_g + 'myForm:saveConfigName').innerHTML +"&nbsp;&nbsp;"+
		    document.getElementById(namespace_g + 'myForm:ConfigModel_oldestfilename').innerHTML;	
			// Defect 8442 adjust dialog to initial size
			if(saveDialogHeightAdded){
				adjustDialogSizeForValidationMessage(700,originHeight - 20- 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);		
				saveDialogHeightAdded = false;
			}
			return launchModal(namespace_g + 'myForm:saveconfirm_dialog', thisEvent);		
		}else {
			// Defect 8442 adjust dialog to initial size
			if(saveDialogHeightAdded){
				adjustDialogSizeForValidationMessage(700,originHeight - 20- 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);		
				saveDialogHeightAdded = false;
			}
			document.getElementById(namespace_g + 'myForm:tosaveNickName').value = save_new_nickname;
		    document.getElementById(namespace_g + 'myForm:confirm_save_OkBtn').click();
		    thisObj.disabled = true;
			showProgressIndicator('spinningDiv_save');		    
		}					
  	}
  	else{  
		 document.getElementById(namespace_g + 'myForm:ConfigModel_saveconfigShow').innerHTML = 
		 	document.getElementById(namespace_g + 'myForm:ConfigModel_saveconfigTxt6').innerHTML  + '<BR><BR>' + 
			document.getElementById(namespace_g + 'myForm:saveConfigName').innerHTML +"&nbsp;&nbsp;"+
		 	document.getElementById(namespace_g + "myForm:tosaveNickName").value;	 
		// Defect 8442 adjust dialog to initial size
		if(saveDialogHeightAdded){
			adjustDialogSizeForValidationMessage(700,originHeight - 20- 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);		
			saveDialogHeightAdded = false;
		}
		 return launchModal(namespace_g + 'myForm:saveconfirm_dialog', thisEvent);					
	}	
}

var backupDialogHeightAdded = false;
//prepares for backup action button
function backupOkBtn(thisObj, thisEvent){
	var originHeight = getOriginalDialogHeight(); 
	var operate  = document.getElementById("operate").value;
	var number = document.getElementById(namespace_g + "myForm:backup_number").value; 
  	
  	var cfgiFrame = parent.getFrame("cfgFrame");
  	var choose_nickname = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_nickname").innerHTML; 
	var choose_description = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_description").innerHTML; 	
	var existed = false;	
	
  	document.getElementById(namespace_g + 'myForm:ConfigModel_backupconfigFirst').innerHTML = "";
	document.getElementById(namespace_g + 'myForm:ConfigModel_backupconfigTxt3').style.display = 'none';	
	
	document.getElementById(namespace_g + "myForm:confirm_backup_OkBtn_button").disabled = false;	  	   
	document.getElementById(namespace_g + "myForm:confirm_backup_CancelBtn").disabled = false;
	
	  			  
	if( operate == 'create'){      
  		var backup_new_nickname = document.getElementById(namespace_g + 'myForm:new_nickname').value;
  		var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
		if(!isDeviceNameValid(backup_new_nickname) || allCfgNames.indexOf(","+backup_new_nickname+",")>=0){
			document.getElementById("fileNameMsg").style.display = ""; 
			document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "";					  
			// Defect 8442 adjust dialog size for validation message
			if (!backupDialogHeightAdded) {
				adjustDialogSizeForValidationMessage(650, originHeight - 0 +20);
				backupDialogHeightAdded = true;
			}
			document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
			return ;
		}else{
			document.getElementById("fileNameMsg").style.display = "none"; 
			document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";					  		
		}
		document.getElementById(namespace_g + 'myForm:backup_source_nickname').value = choose_nickname;
		document.getElementById(namespace_g + 'myForm:backup_target_nickname').value = backup_new_nickname;		 	
	  	document.getElementById(namespace_g + "myForm:confirm_backup_OkBtn").click();	
	  	thisObj.disabled = true;
	  	document.getElementById(namespace_g + 'myForm:backup_CancelBtn').disabled = true;
		// Defect 8442 adjust dialog size to initial size
		if (backupDialogHeightAdded) {
			adjustDialogSizeForValidationMessage(650, originHeight - 20- 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT );
			backupDialogHeightAdded = false;
		}	
	  	showProgressIndicator('spinningDiv');
  	} else {
		 var backup_target_nickname = document.getElementById(namespace_g + 'myForm:backup_target_nickname').value;
		 		 
		 document.getElementById(namespace_g + 'myForm:backup_source_nickname').value = choose_nickname;
		 document.getElementById(namespace_g + 'myForm:ConfigModel_backupconfigFirst').innerHTML = 
		 	document.getElementById(namespace_g + 'myForm:ConfigModel_backupconfigTxt2').innerHTML + '<BR><BR>' + 
		 	document.getElementById(namespace_g + 'myForm:ConfigModel_backupconfigTxt4').innerHTML + "&nbsp;&nbsp;" + removeNbsp(backup_target_nickname);
		 
		 document.getElementById(namespace_g + 'myForm:backup_OkBtn').disabled = true;
		 document.getElementById(namespace_g + 'myForm:backup_CancelBtn').disabled = true;
		 // Defect 8442 adjust dialog size to initial size
		if (backupDialogHeightAdded) {
			adjustDialogSizeForValidationMessage(650, originHeight - 20 - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
			backupDialogHeightAdded = false;
		}
		 return launchModal(namespace_g + 'myForm:backupconfirm_dialog', thisEvent);
    }
}

function removeNbsp(srcStr){
    	return srcStr.substring(srcStr.lastIndexOf("&nbsp;")>=0?srcStr.lastIndexOf("&nbsp;")+"&nbsp;".length:0);
}

function onBackupConfigRadioClick(thisObj){
	
	if(thisObj==null){
		thisObj.checked = true;
		thisObj.value = "true";
	}
	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
    var backup_number = document.getElementById(namespace_g + "myForm:backup_number").value;
	
	    
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("rowSelect1")-1));  
	document.getElementById(namespace_g + "myForm:backup_target_nickname").value = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output").innerHTML;						
    	  	  
    for(var i=0; i < backup_number; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
								   				
				nickname = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output");		
				description = document.getElementById(namespace_g + "myForm:configs_table:"+i+":desc_output");						
			    document.getElementById(namespace_g + "myForm:backup_target_nickname").value = nickname.innerHTML;		    
			}else{
				curr_row.checked=false;
			}	
		}
	}	  
}

// initialize the Replace and SaveAs Radio for Restore
function initDisableBackupRadio() { 
	 document.getElementById(namespace_g + 'myForm:backup_OkBtn').disabled = false;
	 document.getElementById(namespace_g + 'myForm:backup_CancelBtn').disabled = false;
	 
     var radios = null;
     var cfgiFrame = parent.getFrame("cfgFrame");
     var choose_nickname = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_nickname").innerHTML; 
     var choose_description = cfgiFrame.document.getElementById(namespace_g + "myForm:choose_description").innerHTML;
     document.getElementById(namespace_g + "myForm:ConfigModel_Backup_filename").innerHTML = choose_nickname;
     cleanPanelComponent('backup_dialog');
     var backup_number = document.getElementById(namespace_g + "myForm:backup_number").value; 
     		
     var radiolabel1  = document.getElementById("radiolabel1");
     var radiolabel2  = document.getElementById("radiolabel2");
     
     radiolabel1.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText1").innerHTML;      
     radiolabel2.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText2").innerHTML; 
       
     var browser=navigator.appName;
	 if(browser=="Microsoft Internet Explorer")		
		radios = document.all("operate");		  		
	 else
	    radios = document.getElementsByName("operate");		 
				
	 if( radios != null)
	 {
		if( browser=="Microsoft Internet Explorer"){							
			if( backup_number == 0 ) {			
    			radios.item(0).disabled = true;
	    		radios.item(1).disabled = false;
	    		radios.item(1).click();
	    	}
	    	else {
	    		radios.item(0).disabled = false;	      	
	        	radios.item(1).disabled = false;
	        	radios.item(0).click();	        	
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;
	   	 	}					
		 }
		else{	    				  
			if( backup_number == 0 ) {          
	    		radios[0].disabled = true;
	    		radios[1].disabled = false;
	    		radios[1].click();
	    	}
	    	else {
	    	    radios[0].disabled = false;	        	
	        	radios[1].disabled = false;
	        	radios[0].click();	        	
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;	   	 	    
	    	}   	
		}
	 }
	 //Disable the first raido button on the backup step
	 var replaceFileRadios = document.getElementsByName("selected");
	 if(replaceFileRadios != null && replaceFileRadios.length > 0){		 
	 	replaceFileRadios[0].disabled = true;
	 	replaceFileRadios[1].click();
	 }
}

// initialize the Replace and SaveAs Radio for Backup
function initDisableRestoreRadio() { 

	 //document.getElementById(namespace_g + "myForm:confirm_restore_OkBtn").disabled = false;	  	   
	 //document.getElementById(namespace_g + "myForm:confirm_restore_CancelBtn").disabled = false;
	
     var radios = null; 
 	 var servRadios = null;
     cleanPanelComponent('restore_dialog');	
     	
     var configNumber = document.getElementById(namespace_g + "myForm:restore_device_number").value; 
     var serverFileNum = document.getElementById(namespace_g + "myForm:restore_server_number").value;
         
     var radiolabel1  = document.getElementById("radiolabel1");
     var radiolabel2  = document.getElementById("radiolabel2");
     radiolabel1.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText1").innerHTML;
     radiolabel2.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText2").innerHTML;   
     
     document.getElementById(namespace_g + 'myForm:restore_OkBtn').disabled = false;
     if( document.getElementById(namespace_g + 'myForm:restore_CancelBtn')  != null ){
	 document.getElementById(namespace_g + 'myForm:restore_CancelBtn').disabled = false;
     }
     var browser=navigator.appName;
	 if(browser=="Microsoft Internet Explorer")	{	
		radios = document.all("operate");	  		
		servRadios = document.all("servoperate");
	 }	
	 else {
	    radios = document.getElementsByName("operate");	
	    servRadios = document.getElementsByName("servoperate");	 
	 }

	 if( radios != null)
	 {
		if( browser=="Microsoft Internet Explorer"){								
			if( configNumber == 0 ) {			
    			radios.item(0).disabled = true;
	    		radios.item(1).disabled = false;
	    		radios.item(1).click();
	    	}
	    	else {
	    		radios.item(0).disabled = false;
	        	radios.item(0).click();
	        	radios.item(1).disabled = false;
	        	radios.item(1).checked = false;
	        	//onRestoreServerClick(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	   	
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;	   	 	    
	        	
	   	 	}					
		 }
		else{	    				  
			if( configNumber == 0 ) {               
	    		radios[0].disabled = true;
	    		radios[1].disabled = false;
	    		radios[1].click();
	    	}
	    	else {
	    	    radios[0].disabled = false;
	        	radios[0].click();
	        	radios[1].disabled = false;
	        	radios[1].checked = false;
	        	//onRestoreServerClick(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	   	
	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;	   	 	    
	        	
	    	}   	
		}
	 }
	 if( servRadios != null)
	 {
		if( browser=="Microsoft Internet Explorer"){								
			if( serverFileNum == 0 ) {			
    			servRadios.item(0).disabled = true;
	    		servRadios.item(1).disabled = false;
	    		servRadios.item(1).click();
	    	}
	    	else {
	    		servRadios.item(0).disabled = false;
	        	servRadios.item(0).click();
	        	servRadios.item(1).disabled = false;
	        	servRadios.item(1).checked = false;
	        	//onRestoreServerClick(document.getElementById("myForm:configs_table:0:rowSelect1"));	   	
	        	document.getElementById(namespace_g + "myForm:fileupload1").disabled = true;
	   	 	}					
		 }
		else{	    				  
			if( serverFileNum == 0 ) {               
	    		servRadios[0].disabled = true;
	    		servRadios[1].disabled = false;
	    		servRadios[1].click();
	    	}
	    	else {
	    	    servRadios[0].disabled = false;
	        	servRadios[0].click();
	        	servRadios[1].disabled = false;
	        	servRadios[1].checked = false;
	        	//onRestoreServerClick(document.getElementById("myForm:configs_table:0:rowSelect1"));	   	
	   	 	    document.getElementById(namespace_g + "myForm:fileupload1").disabled = true;  	 	    
	    	}   	
		}
	 }
	 var allcheckboxobjs = document.getElementsByTagName("input");
	 for (var k = 0;k < allcheckboxobjs.length;k ++) {
	 	if (allcheckboxobjs[k].type == "checkbox") {
	 		allcheckboxobjs[k].previousSibling.disabled = allcheckboxobjs[k].disabled;	 		
	 	}
	 }
	 // auto select first line
	 var allServerRadios = document.getElementsByName("selected1");
	 if(allServerRadios.length > 1){
	 	allServerRadios[1].click();
	 }
	 var allDeviceRadios = document.getElementsByName("selected");
	 if(allDeviceRadios.length > 0){
	 	allDeviceRadios[0].click();
	 }	 
}

function onRestoreServerClick(thisObj){
	
	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
    var configNumber = document.getElementById(namespace_g + "myForm:restore_server_number").value;
	
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("server_rowSelect1")-1));
	document.getElementById(namespace_g + "myForm:restore_server_path").value = document.getElementById(namespace_g + "myForm:server_configs_table:"+selectedCheckBoxIndex+":server_wwn_output").innerHTML;						
    document.getElementById(namespace_g + "myForm:restore_server_name").value = document.getElementById(namespace_g + "myForm:server_configs_table:"+selectedCheckBoxIndex+":server_nickname_output").innerHTML;						
    	  	  
    for(var i=0; i < configNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
								   				
				nickname = document.getElementById(namespace_g + "myForm:server_configs_table:"+selectedCheckBoxIndex+":server_nickname_output");							
			    document.getElementById(namespace_g + "myForm:restore_server_name").value = nickname.innerHTML;				      
			}else{
				curr_row.checked=false;
			}	
		}
	}	  	
}

function onRestoreDeviceClick(thisObj){

	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
    var configNumber = document.getElementById(namespace_g + "myForm:restore_device_number").value;
	
	          
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("rowSelect1")-1));
	document.getElementById(namespace_g + "myForm:restore_device_name").value = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output").innerHTML;						
    	  	 
    for(var i=0; i < configNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
								   				
				nickname = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output");							
			    document.getElementById(namespace_g + "myForm:restore_device_name").value = nickname.innerHTML;		    
			}else{
				curr_row.checked=false;
			}	
		}
	}	  	
}

function onDownloadServerClick(thisObj){
	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
    var configNumber = document.getElementById(namespace_g + "myForm:restore_server_number").value;
	
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("server_rowSelect1")-1));
						
    	  	  
    for(var i=0; i < configNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
			    				      
			}else{
				curr_row.checked=false;
			}	
		}
	}
}

var restoreDialogHeightAdded = false;
//prepares for restore action button
function restoreOkBtn(thisObj,thisEvent){
	var originHeight = getOriginalDialogHeight();
	document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";
	
	var operate  = document.getElementById("operate").value;
	var servoperates = document.getElementsByName("servoperate");
	var servoperate = "";
	for(var i=0;i<servoperates.length;i++){
		if(servoperates[i].checked){
			servoperate = servoperates[i].value;
			break;
		}
	}
	var configNumber = null; 
 
	var restore_server_name = document.getElementById(namespace_g + "myForm:restore_server_name").value; 
	var restore_device_name = document.getElementById(namespace_g + "myForm:restore_device_name").value; 		
    var existed = false;
    
    document.getElementById(namespace_g + 'myForm:ConfigModel_restoreconfigShow').innerHTML = "";
    document.getElementById(namespace_g + "myForm:confirm_restore_OkBtn_button").disabled = false;	  	   
	document.getElementById(namespace_g + "myForm:confirm_restore_CancelBtn").disabled = false;							    
	
	if (servoperate == 'remote'){
		if( restore_server_name.length == 0){
	    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt5").innerHTML;			 	
		 	return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
		}	
		if( operate == 'create'){ 		       
		    configNumber = document.getElementById(namespace_g + "myForm:restore_all_device_number").value;		     
	  		var restore_new_nickname = document.getElementById(namespace_g + "myForm:new_nickname").value;  	 
	  			  		
		  	var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
			if(!isDeviceNameValid(restore_new_nickname) || allCfgNames.indexOf(","+restore_new_nickname+",")>=0 || restore_new_nickname.indexOf(CONNED_CFG_NAME_PREFIX)==0){
					document.getElementById("fileNameMsg").style.display = ""; 
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "";					  
					// Defect 8442 adjust dialog size for validation message
					if (!restoreDialogHeightAdded) {
						adjustDialogSizeForValidationMessage(710, originHeight - 0 + 20);
						restoreDialogHeightAdded = true;
					}
					document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
					return ;
			}else{
					document.getElementById("fileNameMsg").style.display = "none"; 
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";					  		
			}
      
			if(configNumber >= maxConfig ){	           
				document.getElementById(namespace_g + "myForm:restore_device_name").value = restore_new_nickname;					
								
				document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigShow").innerHTML = 
				document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt7").innerHTML + '  '+ 
			    document.getElementById(namespace_g + "myForm:oldest_device_name").innerHTML + '  '+ 
			    document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt8").innerHTML + '  '+
				document.getElementById(namespace_g + "myForm:restore_device_name").value;
				 // Defect 8442 adjust dialog size to initial size
				if (restoreDialogHeightAdded) {
					adjustDialogSizeForValidationMessage(710, originHeight - 20  - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
					backupDialogHeightAdded = false;
				}
				return launchModal(namespace_g + "myForm:restoreconfirm_dialog",thisEvent);				
			}else if(configNumber<maxConfig){
			    document.getElementById(namespace_g + "myForm:restore_device_name").value = restore_new_nickname ;								    
			    document.getElementById(namespace_g + "myForm:confirm_restore_OkBtn").click();
				 // Defect 8442 adjust dialog size to initial size
				if (restoreDialogHeightAdded) {
					adjustDialogSizeForValidationMessage(710, originHeight - 20  - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
					backupDialogHeightAdded = false;
				}
			    showProgressIndicator('spinningDiv_restore');
			    thisObj.disabled = true;
			    document.getElementById(namespace_g + 'myForm:restore_CancelBtn').disabled = true;
			}					
	  	}
	  	else{  	           
	  		var restore_server_name = document.getElementById(namespace_g + "myForm:restore_server_name").value;
	  		var restore_device_name = document.getElementById(namespace_g + "myForm:restore_device_name").value  
			      
			if( restore_device_name.length == 0){
		    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt9").innerHTML;
				return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
			}
				
	  	    if( restore_server_name.length == 0){
		    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt5").innerHTML;			 	
			 	return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
			} 		 
	  			 					
			document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigShow").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt3").innerHTML;
			 // Defect 8442 adjust dialog size to initial size
			if (restoreDialogHeightAdded) {
				adjustDialogSizeForValidationMessage(710, originHeight - 20  - 2*UTILITYDIALOG_IFRAME_DELTA_HEIGHT);
				backupDialogHeightAdded = false;
			}
			return launchModal(namespace_g + "myForm:restoreconfirm_dialog",thisEvent);		
	    }
    }else{
    	var obj = document.getElementById(namespace_g + "myForm:fileupload1").value;
    	if( operate == 'create'){ 
		    configNumber = document.getElementById(namespace_g + "myForm:restore_all_device_number").value;		     
	  		var restore_new_nickname = document.getElementById(namespace_g + "myForm:new_nickname").value;	  			  		
	  		document.getElementById(namespace_g + "myForm:restore_device_name").value = restore_new_nickname;  	 
	  		
	  	    if( obj.length == 0 || obj == null){	  	       
		    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt5").innerHTML;			 	
			 	return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
			} 		 		
	  		   
		  	var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
			if(!isDeviceNameValid(restore_new_nickname) || allCfgNames.indexOf(","+restore_new_nickname+",")>=0){
					document.getElementById("fileNameMsg").style.display = ""; 
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "";					  
					document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();			  
					return ;
			}else{
					document.getElementById("fileNameMsg").style.display = "none"; 
					document.getElementById(namespace_g + "myForm:fileNameValidatorMsg").style.display = "none";					  		
			}
			
			if(configNumber >= maxConfig ){	           
				document.getElementById(namespace_g + "myForm:restore_device_name").value = restore_new_nickname;					
								
				document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigShow").innerHTML = 
				document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt7").innerHTML + '  '+ 
			    document.getElementById(namespace_g + "myForm:oldest_device_name").innerHTML + '  '+ 
			    document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt8").innerHTML + '  '+
				document.getElementById(namespace_g + "myForm:restore_device_name").value;
				
				return launchModal(namespace_g + "myForm:restoreconfirm_dialog",thisEvent);				
			}		
	  	}
	  	else{ 
	  		var restore_device_name = document.getElementById(namespace_g + "myForm:restore_device_name").value;  
			      
			if( restore_device_name.length == 0){
		    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt9").innerHTML;				
				return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
			}
	  	    if( obj.length == 0 || obj == null){		    	
		    	document.getElementById(namespace_g + "myForm:inforDesTxt").innerHTML = document.getElementById(namespace_g + "myForm:ConfigModel_restoreconfigTxt5").innerHTML;			 	
			 	return launchModal(namespace_g + "myForm:restoreinfor_dialog",thisEvent);
			}
	    }
	    var filename = obj.substring(obj.lastIndexOf('\\')+1);
	    document.getElementById(namespace_g + "myForm:restore_server_name").value = filename;
	    showProgressIndicator('spinningDiv_restore');
	    thisObj.disabled = true;
	    document.getElementById(namespace_g + 'myForm:restore_CancelBtn').disabled = true;
	    document.getElementById(namespace_g + "myForm:restore_download_btn").click();
    }		
}

function clearPanelDialog(thisObj){

	if(thisObj.id ==namespace_g + "myForm:utility_dialog")
		document.getElementById("u_iframe").src="";	
	else if(thisObj.id ==namespace_g + "myForm:cfgAction_dialog")
		document.getElementById("cfgAction_iframe").src="";			
}

function startWait(dialogId){
	// Show the wait section if not already displayed
	if(dialogId == 'utility_dialog'){
		if(document.getElementById("waitDiv_utility").style.display == "none"){		
			document.getElementById("u_iframe").style.height = "0";
			document.getElementById("waitDiv_utility").style.display = "block";			
		}
	}
	else if(dialogId == 'cfgAction_dialog'){	     
		if(document.getElementById("waitDiv_cfgAction").style.display == "none"){	
			document.getElementById("cfgAction_iframe").style.height = "0";	    
			document.getElementById("waitDiv_cfgAction").style.display = "block";						
		}
	}
	else if(dialogId == 'utility_dialog_sec_level'){	
		if(document.getElementById("waitDiv_utility_sec_level").style.display == "none"){		
			document.getElementById("u_iframe_sec_level").style.height = "0";
			document.getElementById("waitDiv_utility_sec_level").style.display = "block";			
		}
	}else if(dialogId == 'util_dialog'){
	   if( document.getElementById('templ_waitDiv_utility')){
		   document.getElementById('templ_waitDiv_utility').style.display = "block";	
		   //document.getElementById('templ_u_iframe_div').style.display = "none";
		   document.getElementById('templ_u_iframe_div').style.visibility = "hidden";	 
		}else if(parent.document.getElementById('templ_waitDiv_utility')){
			parent.document.getElementById('templ_waitDiv_utility').style.display = "block";				
			//parent.document.getElementById('templ_u_iframe_div').style.display = "none";
			parent.document.getElementById('templ_u_iframe_div').style.visibility = "hidden";
	    }
	}	
}

function stopConfigWait(dialogId){
	try{	      		
		if(dialogId == 'utility_dialog'){
			document.getElementById('waitDiv_utility').style.display = "none";
			document.getElementById("u_iframe").style.height = "95%";
		}
		else if(dialogId == 'cfgAction_dialog'){	
			document.getElementById('waitDiv_cfgAction').style.display = "none";
			document.getElementById("cfgAction_iframe").style.height = "95%";		  
		}
		else if(dialogId == 'utility_dialog_sec_level'){	
			document.getElementById('waitDiv_utility_sec_level').style.display = "none";
			document.getElementById("u_iframe_sec_level").style.height = "95%";
		}
	}
	catch(err){
	
	}		
}

function ConfigSubmitAction(thisObj){
	 if(isSelectOptionDisabled(thisObj))
		   return;
	var action = thisObj.options[thisObj.options.selectedIndex].value;

	if(action == "Apply"){	    
		document.getElementById(namespace_g + 'myForm:applyCfg_btn').click();
	}
	if(action == "Backup"){	    
		document.getElementById(namespace_g + 'myForm:backupCfg_btm').click();
		parent.setStorageUtilTitle('backupTitle');
	}
	if(action == "Restore"){
		document.getElementById(namespace_g + 'myForm:restoreCtg_btn').click();
		parent.setStorageUtilTitle('restoreTitle');
	}
	if(action == "Download"){
		document.getElementById(namespace_g + 'myForm:downloadCtg_btn').click();
		parent.setStorageUtilTitle('downloadConfigurationTitle');
	}
	thisObj.options[0].selected = true;
}


function initConfigMenu(){
	var isLaunchedFromHat = document.getElementById(namespace_g + "myForm:launchedFromHat").innerHTML;
	ConfigOptions[0] = new Option(document.getElementById(namespace_g + "myForm:menu_1").innerHTML,'');
	ConfigOptions[1] = new Option(document.getElementById(namespace_g + "myForm:menu_2").innerHTML,'Apply');
	if (isLaunchedFromHat == "false"){
		ConfigOptions[2] = new Option(document.getElementById(namespace_g + "myForm:menu_3").innerHTML,'Backup');
		ConfigOptions[3] = new Option(document.getElementById(namespace_g + "myForm:menu_4").innerHTML,'Restore');
		ConfigOptions[4] = new Option(document.getElementById(namespace_g + "myForm:menu_5").innerHTML,'Download');
	}

	var menu = document.getElementById("menu1");
	 for(var i=0; i<ConfigOptions.length; i++){
	 	menu.options[i]=ConfigOptions[i];
	 	if(i==0 || i>2)
	 		menu.options[i].key = false;
	 	else
	 		menu.options[i].key = true;
	 }
	 	emulate("menu1");	 
}

function enableConfigButtons(flag){
	if(flag){
		document.getElementById(namespace_g + "myForm:save_button").disabled = false;
		document.getElementById(namespace_g + "myForm:deleteAll_visible_button").disabled = false;
		document.getElementById("menu1").disabled = false;
	}
	else{
		document.getElementById(namespace_g + "myForm:save_button").disabled = true;
		document.getElementById(namespace_g + "myForm:deleteAll_visible_button").disabled = true;
		document.getElementById("menu1").disabled = true;
	}
}

function onChooseConfig(thisObj, thisEvent){
	var menu = document.getElementById("menu1");	
	if(thisObj)
	  thisObj.checked = true;
	  thisObj.value="true";
	if(thisObj && thisObj.checked){	
		var showNumber = maxConfig;	
		var idString = thisObj.id;
		var nickname = null;
		
		var selectedCheckBoxIndex = -1;
		selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("rowSelect1")-1));
	
		for(var i=0; i<showNumber; i++){
			var curr_row = document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1");						
			if(curr_row != null){
			    if(i == selectedCheckBoxIndex){
					curr_row.checked=true;
					document.getElementById(namespace_g + "myForm:indexInput").innerHTML = (i+1)+"";
					nickname = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output");						
					document.getElementById(namespace_g + "myForm:choose_nickname").innerHTML = removeNbsp(nickname.innerHTML);
					document.getElementById(namespace_g + "myForm:selected_apply_config").value = i;														
				}else{
					curr_row.checked=false;
				}	
			}
		}
		for(var i=0; i<ConfigOptions.length; i++){
			ConfigOptions[i].key = false;
		}
	emulate("menu1");
	}else if(thisObj){
		initConfigMenu();
	}
}

function setFileSelect(thisObj){
    var fileNumber = document.getElementById(namespace_g + "myForm:restore_server_number"). value;
	var idString = thisObj.id;
	var browser=navigator.appName;
	if(browser !="Microsoft Internet Explorer"  && thisObj.href.indexOf("faces") == -1){
	 	thisObj.href = thisObj.href.substring(0,thisObj.href.length-1)+"faces/page/rbce/storage/ConfigModel.jsp#";
	}
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("ctgFile")-1));
	for(var i=0; i<fileNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1");
		if(curr_row != null){
			if(i == selectedCheckBoxIndex){
				curr_row.checked = true;
			}else{
				curr_row.checked = false;
			}
		}
	}
	document.getElementById(namespace_g + "myForm:downloadBtn").click();
}


function doServOperate(id){
    var serverFileNum = document.getElementById(namespace_g + "myForm:restore_server_number").value;
    var ServDataRadios = document.getElementsByName("selected1");
	if(id == 'remote'){
		document.getElementById(namespace_g + "myForm:fileupload1").disabled = true;
		for( var i=0; i< serverFileNum; i++){	
		    //walkaround solution,modify later,add by qiuhongyan
		    if( document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_nickname_output").innerHTML.indexOf("#") == -1 ){
		        document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1").disabled = false;	
		    }
	   	}
	   	//init check the first one
	   	if(ServDataRadios != null && ServDataRadios.length > 0){
	   		ServDataRadios[1].nextSibling.checked = true;
	   	} else {
	   	/*
	   		var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	   		if ((typeof nextInd) != "undefine") {
	   			nextInd.value = "false";
	   			if (parent) {
	   				parent.refreshNext();
	   			}
	   		}
	   	*/	
	   	}
	}else{
		for( var i=0; i< serverFileNum; i++){							
			document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1").disabled = true;	
			//add by qiuhongyan
			document.getElementById(namespace_g + "myForm:server_configs_table:" + i + ":server_rowSelect1").checked = false;
	   	}
	   	/*
	   	if(ServDataRadios != null){
	   		for(var i = 0; i < ServDataRadios.length; i++){
	   			ServDataRadios[i].checked = false;
	   		}
	   	}*/
	   	document.getElementById(namespace_g + "myForm:fileupload1").disabled = false;
	}
	
	//radio behavior like checkbox,add by qiuhongyan
	if(ServDataRadios != null){
	    for(var i = 0; i < ServDataRadios.length; i++){
	        ServDataRadios[i].disabled = ServDataRadios[i].nextSibling.disabled;
	        ServDataRadios[i].checked = ServDataRadios[i].nextSibling.checked;
	    }
	}	
}

function closeBackupTopDialog(){
	document.getElementById(namespace_g + "myForm:confirmdialog_closer").click();
}
function setStorageUtilTitle(name){
	var prefixObject = document.getElementById(namespace_g + "myForm:" + name);
	var titleStr = document.getElementById(namespace_g + "myForm:storageTitleString").innerHTML;
	if(prefixObject != null){
		titleStr = prefixObject.innerHTML + " - " + titleStr;
	}
	setUtilDialogTitle(titleStr);
}
function setStorageInformationTitle(name){
	var prefixObject = document.getElementById(namespace_g + "myForm:" + name);
	var titleStr = "";
	if(prefixObject != null){
		titleStr = prefixObject.innerHTML
	}
	setUtilDialogTitle(titleStr);
}
function setStorageUtilDialogTitle(){
  var titleStr = document.getElementById(namespace_g + "myForm:storageTitleString").innerHTML;
//  setUtilDialogTitle(titleStr);
}

function setSecLevelUtilDialogTitle(){
	document.getElementById(namespace_g + "myForm:util_dialog_sec_level_tb").lastChild.nodeValue = document.getElementById(namespace_g + "myForm:storageTitleString").innerHTML;;
}

function changeNewGBValue() {
	var tableobj = document.getElementById(namespace_g + "myForm:volumesTable");
	var length = tableobj.getElementsByTagName("tbody")[0].getElementsByTagName("tr").length;
	var additionalCapa = 0;
	var newFlag = false;
	for( var i = 0; i < length; i++) {
		var name1 = namespace_g + "myForm:volumesTable:"+i+":newValue";
		var name2 = namespace_g + "myForm:volumesTable:"+i+":addGB";
		var name3 = namespace_g + "myForm:volumesTable:"+i+":capacity_LongOutput";
		var stradd = document.getElementById(name2).value;
		var add = Number(stradd);
		if(isNaN(add) || add < 0 || stradd.indexOf(".") == 0 || stradd.indexOf(".") == (stradd.length-1)) {
			document.getElementById(name2).focus();
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.display="block";
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.fontSize="12px";
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.fontFamily="Arial";
			//disable next button
			document.getElementById(namespace_g + "myForm:isNext").value="false";
			if (parent) {
				parent.refreshNext();
			}
			return false;
		} if (stradd.indexOf(".") > 0 && stradd.substring(stradd.lastIndexOf(".")+1).length > 3) {		
			document.getElementById(name2).focus();
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display="block";
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.fontSize="12px";
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.fontFamily="Arial";
			//disable next button
			document.getElementById(namespace_g + "myForm:isNext").value="false";
			if (parent) {
				parent.refreshNext();
			}
			return false;		
		} else {
			if(document.getElementById(namespace_g + "myForm:addGBVMsg").style.display=="block") {
				document.getElementById(namespace_g + "myForm:addGBVMsg").style.display="none";
			}
			if(document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display=="block") {
				document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display="none";
			}			
			document.getElementById(namespace_g + "myForm:isNext").value="true";
			if (parent) {
				parent.refreshNext();
			}
		}
		if(add > 0){
			newFlag = true;
		}
		additionalCapa += add;
		document.getElementById(name1).innerHTML = formatDecimal(add, Number(document.getElementById(name3).innerHTML)/1024/1024/1024);
	}
	if(!newFlag) {
		document.getElementById(namespace_g + "myForm:isNext").value="false";
		if (parent) {
			parent.refreshNext();
		}
	} else {
		document.getElementById(namespace_g + "myForm:isNext").value="true";
		if (parent) {
			parent.refreshNext();
		}
	}
	var capa = Number(document.getElementById(namespace_g + "myForm:newAvailableCapacity").innerHTML);
	if(capa < additionalCapa) {
		var poolorvolumetag = document.getElementById(namespace_g + "myForm:PoolOrVolume").value;
		document.getElementById("avail_capa").innerHTML = formatDecimal(additionalCapa - capa);
		document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "";
		document.getElementById("avail_capa").className = "dmc_message";
		document.getElementById(namespace_g + "myForm:capacity_info").style.display = "none";
		
		if (poolorvolumetag == "Pool") {
			document.getElementById(namespace_g + "myForm:isNext").value="false";
			if (parent) {
				parent.refreshNext();
			}
		}
	} else {
		document.getElementById("avail_capa").innerHTML = formatDecimal(capa - additionalCapa);
		document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "none";
		document.getElementById("avail_capa").className = "dmc_outputText";
		document.getElementById(namespace_g + "myForm:capacity_info").style.display = "";
	}
	
	return true;
}
//defined in storagePool.js -- line 27. used when creating volume
var maxVolumeCapacity = 32768;

function SAExpandVolume_changeNewGBValue() {
	var tableobj = document.getElementById(namespace_g + "myForm:volumesTable");
	var length = tableobj.getElementsByTagName("tbody")[0].getElementsByTagName("tr").length;
	var additionalCapa = 0;
	//new check, clear all error messages.
	SAExpandVolume_clearErrMsg();
	for( var i = 0; i < length; i++) {
		var name1 = namespace_g + "myForm:volumesTable:"+i+":newValue";
		var name2 = namespace_g + "myForm:volumesTable:"+i+":addGB";
		var name3 = namespace_g + "myForm:volumesTable:"+i+":capacity_LongOutput";
		var stradd = document.getElementById(name2).value;
		var add = parseDecimal(stradd);
		//isNumber
		if(null==add || add < 0) {
			document.getElementById(name2).focus();
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.display="block";
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.fontSize="12px";
			document.getElementById(namespace_g + "myForm:addGBVMsg").style.fontFamily="Arial";
			document.getElementById(name2).style.fontWeight="bold";
			document.getElementById(name2).style.color="red";
			document.getElementById(name2).style.borderColor="red";
			document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
			return false;
		} 
		var addDecimalValue = String(getDecimal(add));
		if (addDecimalValue.length > 5) {
			document.getElementById(name2).focus();
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display="block";
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.fontSize="12px";
			document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.fontFamily="Arial";
			document.getElementById(name2).style.fontWeight="bold";
			document.getElementById(name2).style.color="red";
			document.getElementById(name2).style.borderColor="red";
			document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
			return false;		
		} 
		var capInGB = parseDecimal(document.getElementById(name3).innerHTML)/1024/1024/1024;
		document.getElementById(name1).innerHTML = formatDecimal(add+capInGB);

		var newCapacitySize = (add+capInGB);
		if(newCapacitySize>maxVolumeCapacity && add!=0){
			document.getElementById(name2).focus();
			document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").style.display="block";
			document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").style.fontSize="12px";
			document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").style.fontFamily="Arial";
			document.getElementById(name1).style.fontWeight="bold";
			document.getElementById(name1).style.color="red";
			document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();			
			return false;
		}
		additionalCapa += add;
	}
	var capa = Number(document.getElementById(namespace_g + "myForm:AvailableCapacityGB").innerHTML);
	if(capa < additionalCapa) {
		document.getElementById("avail_capa").innerHTML = formatDecimal(additionalCapa - capa);
		document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "";
		document.getElementById(namespace_g + "myForm:avail_capa_format").className = "dmc_message";
		document.getElementById(namespace_g + "myForm:capacity_info").style.display = "none";
		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
		return false;
	} else {
		document.getElementById("avail_capa").innerHTML = formatDecimal(capa - additionalCapa);
		document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "none";
		document.getElementById(namespace_g + "myForm:avail_capa_format").className = "dmc_outputText";
		document.getElementById(namespace_g + "myForm:capacity_info").style.display = "";
	}
	
	if(additionalCapa<=0){
		document.getElementById(namespace_g + "myForm:noCapacityAdded").style.display = "";
		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
		return false;
	}
	//check passed, clear all error message
	SAExpandVolume_clearErrMsg();
	return true;
}

function SAExpandVolume_clearErrMsg(){
	document.getElementById(namespace_g + "myForm:addGBVMsg").style.display="none";
	document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display="none";
	document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").style.display="none";
	document.getElementById(namespace_g + "myForm:noCapacityAdded").style.display = "none";
}

function SAExpandVolume_refNewGBValue() {
	var tableobj = document.getElementById(namespace_g + "myForm:volumesTable");
	var length = tableobj.getElementsByTagName("tbody")[0].getElementsByTagName("tr").length;
	var additionalCapa = 0;
	var result = true;
	var nanError = false;
	var decimaError = false;
	var sizeError = false;
	for( var i = 0; i < length; i++) {
		var name1 = namespace_g + "myForm:volumesTable:"+i+":newValue";
		var name2 = namespace_g + "myForm:volumesTable:"+i+":addGB";
		var name3 = namespace_g + "myForm:volumesTable:"+i+":capacity_LongOutput";
		var additionObj = document.getElementById(name2);
		var stradd = additionObj.value;
		var add = parseDecimal(stradd);
		if(null==add || add < 0) {
			result = false;
			nanError = true;
			break;
		}
		else
		{
			document.getElementById(name2).style.fontWeight="";
			document.getElementById(name2).style.color="black";
			document.getElementById(name2).style.borderColor="black";
		}
		
		var addDecimalValue = String(getDecimal(add));
		if (addDecimalValue.length > 5) {
			result = false;
			decimaError = true;
			break;
		}		
				
		var capInGB = Number(document.getElementById(name3).innerHTML)/1024/1024/1024;
		document.getElementById(name1).innerHTML = formatDecimal(add+capInGB);
		document.getElementById(namespace_g + "myForm:volumesTable:"+i+":addGBBindingField").value = (add)*1024*1024*1024;
		
		var newCapacitySize = (add+capInGB);
		if(newCapacitySize>maxVolumeCapacity && add!=0){
			result = false;
			sizeError = true;
			break;
		}else{
			document.getElementById(name1).style.fontWeight="";
			document.getElementById(name1).style.color="black";	
		}		
		additionalCapa += add;
	}
	
	document.getElementById(namespace_g + "myForm:addGBVMsg").style.display=nanError?"block":"none";
	document.getElementById(namespace_g + "myForm:decimaPrecisionMsg").style.display=decimaError?"block":"none";
	document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").style.display=sizeError?"block":"none";
	
	if(!nanError&&!decimaError&&!sizeError)
	{
		var capa = Number(document.getElementById(namespace_g + "myForm:AvailableCapacityGB").innerHTML);
		if(capa < additionalCapa) {
			document.getElementById("avail_capa").innerHTML = formatDecimal(additionalCapa - capa);
			document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "";
			document.getElementById(namespace_g + "myForm:avail_capa_format").className = "dmc_message";
			document.getElementById(namespace_g + "myForm:avail_capa_format").style.display = "";
			document.getElementById(namespace_g + "myForm:capacity_info").style.display = "none";
			result = false;
		} else {
			document.getElementById("avail_capa").innerHTML = formatDecimal(capa - additionalCapa);
			document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "none";
			document.getElementById(namespace_g + "myForm:avail_capa_format").className = "dmc_outputText";
			document.getElementById(namespace_g + "myForm:avail_capa_format").style.display = "";
			document.getElementById(namespace_g + "myForm:capacity_info").style.display = "";
		}
	}
	else
	{
	 	document.getElementById(namespace_g + "myForm:avail_capa_format").style.display = "none";
		document.getElementById(namespace_g + "myForm:additional_capacity_need").style.display = "none";
		document.getElementById(namespace_g + "myForm:capacity_info").style.display = "none";
	}
	
	return result;
}

function onLoad_SAExpandVolume(){
	var tableobj = document.getElementById(namespace_g + "myForm:volumesTable");
	var length = tableobj.getElementsByTagName("tbody")[0].getElementsByTagName("tr").length;
	for( var i = 0; i < length; i++) {
		var name2 = namespace_g + "myForm:volumesTable:"+i+":addGB";
		var additionObj = document.getElementById(name2);
		var stradd = additionObj.value;
		if(stradd.length==0){
			additionObj.value="0";
			stradd="0";
		}	
	}		
	SAExpandVolume_refNewGBValue();
	parent.stopWait("util_dialog");
	
	// initial error message	
	alignHeaderTableAndContentTable("headerTableDivId","volumesTable");
	innerMessagesInstance.init();
	setSAExpandVolumeFormStyle();
}

function setSAExpandVolumeFormStyle(){
	var _outerSize = "0px";
  	var _height = "0%";
	if (document.all){//IE
	     var _myform = document.getElementById(namespace_g + "myForm");        
	     if( _myform != null){
	           _myform.style.margin = _outerSize;
	           _myform.style.padding = _outerSize;
	           _myform.style.height = _height;
	      }
	 }
}

function doCheckExpandVolumePrecondition(){
    if(!chekExpandVolumePrecondition()){
       	document.getElementById(namespace_g + "myForm:expandVolumeWarningPopuper").click();
        return false;
    }else{
		document.getElementById(namespace_g + "myForm:expandVolumePopuper").click();
		parent.setStorageUtilTitle("expandVolumeTitle");
		return true;
	}
}

function chekExpandVolumePrecondition(){
	var checkPass = true;
	var poolName = "";
	var lastPoolName = "";
	var allCheckBoxes = getElementsByTagNameAndType("input","checkbox");
	for(var i=0; i<allCheckBoxes.length; i++) {
		var boxObj = allCheckBoxes[i];
		var boxId = boxObj.id;
		if(boxId != null && boxId.indexOf("rowSelectShow") > -1) {
			if (boxObj.checked) {
				if(""==lastPoolName){
					lastPoolName = volumeTab_getParentPool(boxObj);
				}
				poolName = volumeTab_getParentPool(boxObj);
				if(poolName != lastPoolName){
					checkPass = false;
					break;
				}
			}
		}
	}
	return checkPass;
}

function volumeTab_getParentPool(checkBoxObj){
	var parentTRObj = checkBoxObj.parentNode;
	while(parentTRObj.tagName.toLowerCase() != "tr"){
		parentTRObj = parentTRObj.parentNode;
	}
	var spanobjs = parentTRObj.getElementsByTagName("span");
	var currentspan = null;
	for (var i = 0;i < spanobjs.length;i ++) {
		if (spanobjs[i].id.indexOf("storagepool_output") != -1) {
			currentspan = spanobjs[i];
			break;
		}
	}
	
	if (currentspan != null) {
		return currentspan.innerHTML;
	}else{
		return "";
	}
}

function SAExpandVolume_ajaxSubmit(){
	document.getElementById(namespace_g + "myForm:submitBtn").disabled = true;
	document.getElementById(namespace_g + "myForm:closeBtn").value = document.getElementById(namespace_g + "myForm:closeBtnLabel").innerHTML;
	
	var closeMsgBtnDivObj = document.getElementById("closeButton_div");
	if (closeMsgBtnDivObj) {
		var imgObjs = closeMsgBtnDivObj.getElementsByTagName("img");
		if (imgObjs) {
			innerMessagesInstance.clearMessage(imgObjs[0]);
		}
	}
	document.getElementById("main_ExpandVolume_tab").style.display = "none";
	document.getElementById("main_progress_div").style.display = "block";
}

function SAExpandVolume_CheckResult(){
    if ("true" == document.getElementById(namespace_g + "myForm:finishFlag").innerHTML) {
        if ("true" != document.getElementById(namespace_g + "myForm:errorOccured").innerHTML) {
            parent.closeUtilDialog();
            /*var hostWindow;
            if (parent.document.getElementById('hostIframe').contentDocument) {
                hostWindow = parent.document.getElementById('hostIframe').contentDocument;
                hostWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/HostsTab.jsp";
            }
            else {
                hostWindow = parent.document.getElementById('hostIframe').contentWindow;
                hostWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
            }
            var volumeWindow;
            if (parent.document.getElementById('iframe1').contentDocument) {
                volumeWindow = parent.document.getElementById('iframe1').contentDocument;
                volumeWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/VolumesTab.jsp";
            }
            else {
                volumeWindow = parent.document.getElementById('iframe1').contentWindow;
                volumeWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
            }
			var poolWindow;
			if(parent.document.getElementById('iframe2').contentDocument){
				poolWindow = parent.document.getElementById('iframe2').contentDocument;
				poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
			}else{
				poolWindow = parent.document.getElementById('iframe2').contentWindow;
				poolWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
			}*/
			parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_HOST);
        }
        else {
            document.getElementById("main_ExpandVolume_tab").style.display = "block";
            document.getElementById("main_progress_div").style.display = "none";
            document.getElementById(namespace_g + "myForm:volumesTable").focus();
            document.getElementById(namespace_g + "myForm:volumesTable").blur();
			document.getElementById(namespace_g + "myForm:submitBtn").disabled = false;
			document.getElementById(namespace_g + "myForm:closeBtn").value = document.getElementById(namespace_g + "myForm:cancelBtnLabel").innerHTML;
			innerMessagesInstance.display();
        }
    }else{
		
		setTimeout(lazyRefExpandVolume,1000);
	}
}

function lazyRefExpandVolume(){
	document.getElementById(namespace_g + "myForm:sendAjaxBtn").click();
}

function expVolSubmitBtnClick(){
	if(SAExpandVolume_changeNewGBValue()){
		document.getElementById(namespace_g + 'myForm:sendAjaxBtn').click();
	}
}

//This function will hide the main contents while page is refreshing with refresh button
//flag -- true=display contents; false = hide contents
function displayExpandVolumeMainContents(flag){
	var precondition = document.getElementById(namespace_g + "myForm:precondition").value;
	if(precondition == "false") {
		document.getElementById(namespace_g + "myForm:isNext").value="false";
	}
	if (parent) {
		parent.refreshNext();
	}
	if(flag){
		document.getElementById('request_div').style.display = 'block';
		document.getElementById('progress_div').style.display = 'none';
	}
	else{
		document.getElementById('request_div').style.display = 'none';
		document.getElementById('progress_div').style.display = 'block';
	}	
}
		
function onLoad_VolumesTab(){
	disableRefreshButton (true); // Disable the refresh button before common page load. 
	initErrorMessage(); // Initialise the error message for the page.
	if(hX_5.brw.isIE()){ // IE
		parent.loadFrame("iframe1");
	}else{ // FF
		hX_5.addBehavior("#body", "onload", new hX_5.JSFBehaviorGeneric("action:get;", "target:" + namespace_g + "myForm:ajaxpanel")); 
	}
}

function onLoad_PoolsTab(){
	disableRefreshButton (true); // Disable the refresh button before common page load. 
	initErrorMessage(); // Initialise the error message for the page.
	if(hX_5.brw.isIE()){ // IE
		parent.loadFrame("iframe2");
	}else{ // FF
		hX_5.addBehavior("#body", "onload", new hX_5.JSFBehaviorGeneric("action:get;", "target:" + namespace_g + "myForm:ajaxpanel")); 
	}
}
function onLoad_DisksTab(){
	disableRefreshButton (true); // Disable the refresh button before common page load. 
	initErrorMessage(); // Initialise the error message for the page.
	if(hX_5.brw.isIE()){ // IE
		parent.loadFrame("iframe4");
	}else{ // FF
		hX_5.addBehavior("#body", "onload", new hX_5.JSFBehaviorGeneric("action:get;", "target:" + namespace_g + "myForm:ajaxpanel")); 
	}
}

function onLoad_ConfigModel(){
	disableRefreshButton (true); // Disable the refresh button before common page load. 
	initErrorMessage(); // Initialise the error message for the page.
	if(hX_5.brw.isIE()){ // IE
		parent.loadFrame("cfgFrame");
	}else{ // FF
		hX_5.addBehavior("#body", "onload", new hX_5.JSFBehaviorGeneric("action:get;", "target:" + namespace_g + "myForm:ajaxpanel")); 
	}
}

function onLoad_PoolGeneralProperties(){
	// Call the common function to send the ajax request
	commonPageLoad();
}
function onLoad_AssociatedDisk(){
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_PoolRelatedDisks(){
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_PoolAdvanceProperties(){
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_VolumesGeneral(){
	// Call the common function to send the ajax request
	commonPageLoad();
}
function onLoad_PoolAssolatedVolumes(){
	// Call the common function to send the ajax request
	commonPageLoad();
}
function onLoad_VolumesAdvanced(){
	// Call the common function to send the ajax request
	commonPageLoad();
}
function selectTab(tabId){
	 var tab=namespace_g + "myForm:tabbedPanelProperties:"+tabId;
	 eval(ns + 'ODCTabPanelControlVar1').restoreUIState(tab);
}

function onLoad_WizardSaveConfig(){
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";
	
	if (parent) {
		parent.refreshNext();
	}
	
	// Call the common function to send the ajax request
	commonPageLoad();
}

function disableSaveCfgRadioInWizard(){
	var radios = null; 
                    
     var configNumber = document.getElementById(namespace_g + "myForm:configNumber").innerHTML; 

     var radiolabel1  = document.getElementById("radiolabel1");
     var radiolabel2  = document.getElementById("radiolabel2");  
     
     radiolabel1.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText1").innerHTML;
     radiolabel2.innerHTML  = document.getElementById(namespace_g + "myForm:radiolabeText2").innerHTML; 
     
     cleanPanelComponent('save_dialog');
     
     var browser=navigator.appName;
	 if(browser=="Microsoft Internet Explorer"){		
		radios = document.all("operate");
	 }		  		
	 else{
	    radios = document.getElementsByName("operate");
	 }		 

	 if( radios != null)
	 {
		if( browser=="Microsoft Internet Explorer"){								
			if( configNumber == 0 ) {			
    			radios.item(0).disabled = true;
	    		radios.item(1).disabled = false;
	    		radios.item(1).click();
	    	}
	    	else {
	    		radios.item(0).disabled = false;	        	
	        	radios.item(1).disabled = false;  
	        	radios.item(0).click();      	 
//        	    onSaveConfigRadioClickInWizard(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));
//	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;	   	 	    
	   	 	}					
		 }
		else{	   		     				  
			if( configNumber == 0 ) {  //           
	    		radios[0].disabled = true;
	    		radios[1].disabled = false;
	    		radios[1].click();
	    	}
	    	else {
	    	    radios[0].disabled = false;	        	
	        	radios[1].disabled = false;
      			radios[0].click();
//	        	onSaveConfigRadioClickInWizard(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	   	
//	   	 	    document.getElementById(namespace_g + "myForm:new_nickname").disabled = true;
	    	}   	
		}
	 }
}

function AutoSelectFirstCfg(){
	var configNumber = document.getElementById(namespace_g + "myForm:configNumber").innerHTML;
	if(configNumber!=0){
		var historyCfgName = document.getElementById(namespace_g + "myForm:historySelectCfg").innerHTML;
		if (historyCfgName != "") {
			for (var i = 0;i < configNumber;i ++) {
				if (document.getElementById(namespace_g + "myForm:configs_table:" + i + ":nickname_output").innerHTML == historyCfgName) {
					onSaveConfigRadioClickInWizard(document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1"));
					return;
				}
			}
		} else {
		onSaveConfigRadioClickInWizard(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));
		}
	}
}

//auto select the first one on configuations from SCM Server,add by qiuhongyan,
function autoSelectFirstCfgOnServer(){
	 var allcheckboxobjs = document.getElementsByTagName("input");
	 for (var k = 0;k < allcheckboxobjs.length;k ++) {
	 	if (allcheckboxobjs[k].type == "checkbox") {
	 		allcheckboxobjs[k].previousSibling.disabled = allcheckboxobjs[k].disabled;	 		
	 	}
	 }
	 
	 // auto select first line
	 var allServerRadios = document.getElementsByName("selected1");
	 if(allServerRadios.length > 1){
	 	allServerRadios[1].click();
	 }
}


function onSaveConfigRadioClickInWizard(thisObj, thisEvent){
	var idString = thisObj.id;
	var nickname = null;
	var description = null; 
           
	var selectedCheckBoxIndex = idString.substring((idString.indexOf("table") + 6), (idString.indexOf("rowSelect1")-1));
     
    document.getElementById(namespace_g + "myForm:indexInput").innerHTML = selectedCheckBoxIndex-0+1;
        
	document.getElementById(namespace_g + "myForm:tosaveNickName").value = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output").innerHTML;						  			  			    
	//defect 8633,comment description because provider not supported.
    //document.getElementById("myForm:tosaveDescription").value = document.getElementById("myForm:configs_table:"+selectedCheckBoxIndex+":desc_output").innerHTML;
    	   
    var configNumber = document.getElementById(namespace_g + "myForm:configNumber").innerHTML;
		
    for(var i=0; i < configNumber; i++){
		var curr_row = document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1");						
		if(curr_row != null){
		    if(i == selectedCheckBoxIndex){
				curr_row.checked=true;
				  
				document.getElementById(namespace_g + "myForm:indexInput").innerHTML = i-0+1;				  				  
				nickname = document.getElementById(namespace_g + "myForm:configs_table:"+selectedCheckBoxIndex+":nickname_output");		
				description = document.getElementById(namespace_g + "myForm:configs_table:"+i+":desc_output");						
			    document.getElementById(namespace_g + "myForm:tosaveNickName").value = nickname.innerHTML;			        
			    //defect 8633,comment description because provider not supported.	        
			    //document.getElementById("myForm:tosaveDescription").value = description.innerHTML;
		    	document.getElementById(namespace_g + "myForm:selected_apply_config").value = i;
			}else{
				curr_row.checked=false;
			}	
		}
	}
	
	//check the radio according to checkbox,add by qiuhongyan	
	var radioSelectedDeviceConfig = document.getElementsByName("radioSelectedConfig");
	if(radioSelectedDeviceConfig.length>0)  
	for(var i=0; i < radioSelectedDeviceConfig.length; i++){
	    radioSelectedDeviceConfig[i].checked = radioSelectedDeviceConfig[i].nextSibling.checked;
	}
}

function doOperateInWizard(id, action){		
 
   var number = document.getElementById(namespace_g + "myForm:configNumber").innerHTML;	
          
   if( action == 'backup'){
   	   number = document.getElementById(namespace_g + "myForm:backup_number").value;
   	}   
   	  
   if( action == 'restore_device'){
   	   number = document.getElementById(namespace_g + "myForm:restore_device_number").value;
   	}     
   	 
   if( id == 'replace'){ 
       var i=0;
   	   if( action == 'backup'){ 	     
   	   	   i=1 ;
	   }
	   for( ; i < number; i++){										
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = false;
	   }
	   	   	     	   
	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = true; 
	   
	   if( action == 'save'){
           onSaveConfigRadioClickInWizard(document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1"));	  	   
   	   }
   }    
   if( id == 'create'){
   	   for( var i=0; i< number; i++){							
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = true;	
	   }

	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = false;
	   //if( action == 'saveas')
	   //    document.getElementById(namespace_g + "myForm:new_description").disabled = false; 
   }
   
   document.getElementById("operate").value = id;	
}

function onLoad_WizardBackupConfigTarget(){
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";
    //add by qiuhongyan, clear the previous value when loaded
    document.getElementById(namespace_g + "myForm:restore_server_name").value = ''; 
	if (parent) {
		parent.refreshNext();
	}
	
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_WizardBackupConfigLocal(){
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";
	
	if (parent) {
		parent.refreshNext();
	}
	// Call the common function to send the ajax request
	commonPageLoad();
}


function doRestoreOperate(id, action){		
 
   var number = 0;	
              	  
   if( action == 'restore_device'){
   	   number = document.getElementById(namespace_g + "myForm:restore_device_number").value;
   	}     
   	 
   if( id == 'replace'){ 
       var i=0;
	   for( ; i < number; i++){										
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = false;
	   }
	   	   	     	   
	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = true; 
	   //init check the first one,add by qiuhongyan
	   document.getElementById(namespace_g + "myForm:configs_table:0:rowSelect1").checked = true;
	   document.getElementById(namespace_g + "myForm:restore_device_name").value = document.getElementById(namespace_g + "myForm:configs_table:0:nickname_output").innerHTML;
   }    
   if( id == 'create'){
   	   for( var i=0; i< number; i++){							
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").disabled = true;
            //remove preivious checked when disabled,add by qiuhongyan
			document.getElementById(namespace_g + "myForm:configs_table:" + i + ":rowSelect1").checked = false;				
	   }

	   document.getElementById(namespace_g + "myForm:new_nickname").disabled = false;
	   /*
	   var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	   if ((typeof nextInd) != "undefine" && document.getElementById(namespace_g + "myForm:new_nickname").value == "") {
	   		nextInd.value = "false";
	   		if (parent) {
	   			parent.refreshNext();
	   		}
	   }*/
   }
   
   document.getElementById("operate").value = id;	
   
	//radio behavior like checkbox,add by qiuhongyan
	var radios = document.getElementsByName("selected");
	if(radios != null){
	    for(var i = 0; i < radios.length; i++){
	        radios[i].disabled = radios[i].nextSibling.disabled;
	        radios[i].checked = radios[i].nextSibling.checked;
	    }
	}
}

function restoreSourceOK(thisObj,thisEvent){
	if (typeof document.getElementById(namespace_g + "myForm:upload_errmsg") != "undefine") {
		document.getElementById(namespace_g + "myForm:upload_errmsg").style.display = "none";
	}
	var servoperates = document.getElementsByName("servoperate");
	var servoperate = "";
	for(var i=0;i<servoperates.length;i++){
		if(servoperates[i].checked){
			servoperate = servoperates[i].value;
			break;
		}
	}
	var configNumber = null; 
 
	var restore_server_name = document.getElementById(namespace_g + "myForm:restore_server_name").value; 		
    var existed = false;
									    
	
	if (servoperate == 'remote'){
		if( restore_server_name.length == 0){	        					
    		if (parent) {
    			parent.refreshNext();
    		}
			return false;
		}	
	}else{
    	var obj = document.getElementById(namespace_g + "myForm:fileupload1").value;
    	if (obj == "" && ((typeof document.getElementById(namespace_g + "myForm:isNext")) != "undefine")) {
    		document.getElementById(namespace_g + "myForm:upload_errmsg").style.display = "block";
    		if (parent) {
    			parent.refreshNext();
    		}
    		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
    		return;
    	}
	    var filename = obj.substring(obj.lastIndexOf('\\')+1);
	    document.getElementById(namespace_g + "myForm:restore_server_name").value = filename;	    
    }
    document.getElementById(namespace_g + "myForm:restore_source_operation").value = servoperate;	
    document.getElementById(namespace_g + "myForm:restore_file_name").value = document.getElementById(namespace_g + "myForm:fileupload1").value;	
    document.getElementById(namespace_g + "myForm:restore_source_btn").click();	
}

function restoreCfgTargetBtn(){
    var flag = true;
	var operate  = document.getElementById("operate").value;
	var configNumber = null; 
 	
									    	
	if( operate == 'create'){ 
	     //defect 7170,move the validation when click next instead of onblur
        if(!Wizard_CheckBackupLocal()){
            flag = false;
        }
	    configNumber = document.getElementById(namespace_g + "myForm:restore_device_number").value;
	     
  		var restore_new_nickname = document.getElementById(namespace_g + "myForm:new_nickname").value;
  		document.getElementById(namespace_g + "myForm:restore_device_name").value = restore_new_nickname;  	    
  		if( restore_new_nickname == ''){            
  			flag = false; 						
		} 						
  	}
  	else{  	           
  		var restore_device_name = document.getElementById(namespace_g + "myForm:restore_device_name").value;
		if( restore_device_name==null || restore_device_name.length == 0){
	    	flag = false;
		} 		 		
    }
    if(flag){
        document.getElementById(namespace_g + "myForm:upload_errmsg").style.display="none";
    	document.getElementById(namespace_g + "myForm:show_confirm_dialog_btn").click();
    }else{
        if(parent)
            parent.refreshNext();
        return flag;
    }

}

function Wizard_CheckBackupLocal() {
    var result = true;
	var obj = document.getElementById(namespace_g + "myForm:new_nickname");
	var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	var allCfgNames = document.getElementById(namespace_g + "myForm:allCfgNames").innerHTML;
	if (isDeviceNameValid(obj.value) && obj.value.indexOf(CONNED_CFG_NAME_PREFIX)!=0 && allCfgNames.indexOf(","+obj.value+",")<0 ) {
		result = true;
		document.getElementById(namespace_g + "myForm:upload_errmsg").style.display="none";
	} else {
		result = false;
		document.getElementById(namespace_g + "myForm:upload_errmsg").style.display="";
		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
	}
	return result;
}

/**
 * Set the seperated class style for the table rows
 *
 */
function setTableClass(tableID) {
	var rows = document.getElementById(tableID).tBodies[0].rows;
			
	for(var i=0; i<rows.length; i++) {
		if(i%2 == 0) {
			rows[i].className = "dmc_rowClass1";
		} else {
			rows[i].className = "dmc_rowClass2";
		}		
	}
}

/**
 * Update the image of the clicked column header when user clicks it
 *
 */
function updateClickedColumnHeaderImg(spanID) {
	var oNode = document.getElementById(spanID);
	var cs = oNode.childNodes;
	var initSrc = cs[1].src;
	if (initSrc.lastIndexOf("1x1.gif") > -1 || initSrc.lastIndexOf("sortbi.gif") > -1) {
		cs[1].src = document.global_context_path + "/images/sortbiup.gif";
		cs[1].title=bundle.Common_SortHeaderTitle_sortbiup;
		cs[1].alt=bundle.Common_SortHeaderTitle_sortbiup;
	} else if (initSrc.lastIndexOf("sortbiup.gif") > -1) {
		cs[1].src = document.global_context_path + "/images/sortbidown.gif";
		cs[1].title=bundle.Common_SortHeaderTitle_sortbidown;
		cs[1].alt=bundle.Common_SortHeaderTitle_sortbidown;
	} else if (initSrc.lastIndexOf("sortbidown.gif") > -1) {
		cs[1].src = document.global_context_path + "/images/sortbiup.gif";
		cs[1].title=bundle.Common_SortHeaderTitle_sortbiup;
		cs[1].alt=bundle.Common_SortHeaderTitle_sortbiup;
	}
}

/**
 * Update all other images of the column headers except for the clicked column header
 *
 */
function updateAllOtherColumnHeaderImg(spanID) {
	updateClickedColumnHeaderImg(spanID);
    for(var i=0; i<headerSpanIDs.length; i++) {
    	if (spanID != headerSpanIDs[i]) {
			var oNode = document.getElementById(headerSpanIDs[i]);
			if(oNode)
			{
				var cs = oNode.childNodes;
				var initSrc = cs[1].src;
				cs[1].src = document.global_context_path + "/images/sortbi.gif";    	
				cs[1].title=bundle.Common_SortHeaderTitle_sortInit;
				cs[1].alt=bundle.Common_SortHeaderTitle_sortInit;
			}
    	}
    }
}

/**
 * Sort the storage table by the table column
 *
 */
function sortStorageTable(tableColumn) {
	sorttable.sort(tableColumn);
	setTableClass(sortTableID);

    for(var i=0; i<headerSpanIDs.length; i++){
    	if(i == (tableColumn-1)) {
			updateAllOtherColumnHeaderImg(headerSpanIDs[i]);    	
    	}
    }
    document.getElementById(sortTableID).focus();
    if(sortTableID != storageTables[3]) {
    	unselectedCheckbox();
    }
}

/**
 * Unselected all checkboxs after sotring the data table
 *
 */
function unselectedCheckbox(){
	var checkBoxs = getElementsByTagNameAndType("input","checkbox");

	for(var i=0; i<checkBoxs.length; i++){
		checkBoxs[i].checked = false;
	}
		
	switch(sortTableID) {
		case storageTables[0]:
			initVolumeMenu();
			break;
		case storageTables[1]:
			initMenu();
 			document.getElementById(namespace_g + "myForm:createStorageVolume").disabled = true;
			break;
		case storageTables[2]:
			initDiskMenu();
			uncheckAllRows(namespace_g + "myForm:disksTable");
			document.getElementById(namespace_g + "myForm:LocateDriveBtn").disabled = true;
			document.getElementById(namespace_g + "myForm:AssignGlobalSpareBtn").disabled = true;
			break;
		//case storageTables[3]:
			//initConfigMenu();
			//break;
	}
}

/**
 * Uncheck all rows for a data table
 *
 */
function uncheckAllRows(tableId)
{
	var elmt = document.getElementById(tableId);
	if(elmt==null)
		return;
	var tbody = elmt.getElementsByTagName("tbody");
	if(tbody==null || tbody.length==0)
		return;
	trs = tbody[0].getElementsByTagName("tr");
	for(var i=0;i<trs.length;i++){
	  var node = trs[i];
	  while(node){
		 node = node.childNodes[0];	
		 if(node)
			 if(node.tagName)
			    if(node.tagName=="INPUT")
			    	break;
	  }
	  if(node){
		  if(node.tagName=="INPUT" && node.checked)
			node.checked = false;
		}
	}
}


/**
 * Get elements by the tag name and the type
 *
 */
function getElementsByTagNameAndType(tagName, type){
	var checkBoxs = new Array();
	var tags = document.getElementsByTagName(tagName);
	var index = 0;
	for(var i=0; i<tags.length; i++){
		var tmpType = tags[i].getAttribute("type");
		if(tmpType == type){
			checkBoxs[index] = tags[i];
			index++;
		}
	}
	return checkBoxs;
}

var sorttable = null;
var headerSpanIDs = null;
var sortTableID = null; 
var headerTypes = null;

//All the storage table ids
var storageTables = new Array(namespace_g + "myForm:volumesTable",namespace_g + "myForm:storagePoolTable",namespace_g + "myForm:disksTable",namespace_g + "myForm:configs_table");
//The volumes' data
var volumesHeaderIDs = new Array(namespace_g + "myForm:DataTableHead:volumes_sort_name",namespace_g + "myForm:DataTableHead:volumes_sort_status",
								 namespace_g + "myForm:DataTableHead:volumes_sort_capacity",namespace_g + "myForm:DataTableHead:volumes_sort_pool",
								 namespace_g + "myForm:DataTableHead:volumes_sort_raid","");
var volumesTableColumnTypes = new Array("String", "VolumeName", "String", "Number","String","String","");
//The pools' data
var poolsHeaderIDs = new Array(namespace_g + "myForm:DataTableHead:pools_sort_name",namespace_g + "myForm:DataTableHead:pools_sort_status",
							   namespace_g + "myForm:DataTableHead:pools_sort_total",namespace_g + "myForm:DataTableHead:pools_sort_avaliable",
							   namespace_g + "myForm:DataTableHead:pools_sort_volumenumber",namespace_g + "myForm:DataTableHead:pools_sort_raidtype",
							   namespace_g + "myForm:DataTableHead:pools_sort_sparecoverage");
var poolsTableColumnTypes = new Array("String","String", "String", "Number", "Number","Number","String","String");
//The disks' data
var disksHeaderIDs = new Array(namespace_g + "myForm:DataTableHead:disks_sort_module",namespace_g + "myForm:DataTableHead:disks_sort_bay",
							   namespace_g + "myForm:DataTableHead:disks_sort_status",namespace_g + "myForm:DataTableHead:disks_sort_state",
							   namespace_g + "myForm:DataTableHead:disks_sort_capacity",namespace_g + "myForm:DataTableHead:disks_sort_speed",
							   namespace_g + "myForm:DataTableHead:disks_sort_type","");
var disksTableColumnTypes = new Array("String","Number", "Number","String","String","Number","Number","String","");
//The configurations' data
var configsHeaderIDs = new Array(namespace_g + "myForm:DataTableHead:configs_sort_name",namespace_g + "myForm:DataTableHead:configs_sort_date");
var configsTableCoumnTypes = new Array("String","String","Date");							   

/**
 * Initilize the storage table for the sorting
 *
 */					 								 
function initStorageTable(tableId) {	
	sortTableID = tableId;
	
	switch(sortTableID) {
		case storageTables[0]:
			headerSpanIDs = volumesHeaderIDs;
			headerTypes = volumesTableColumnTypes;
			break;
		case storageTables[1]:
			headerSpanIDs = poolsHeaderIDs;
			headerTypes = poolsTableColumnTypes;
			break;
		case storageTables[2]:
			headerSpanIDs = disksHeaderIDs;
			headerTypes = disksTableColumnTypes;
			break;
		case storageTables[3]:
			headerSpanIDs = configsHeaderIDs;
			headerTypes = configsTableCoumnTypes;
			break;
	}
	
	//update the header links
    for(var i=0; i<headerSpanIDs.length; i++){
    	if (document.getElementById(headerSpanIDs[i])) {
	    	document.getElementById(headerSpanIDs[i]).href="javascript:;";
	    }
    }
    
    if (document.getElementById(tableId)) {
	    //Create the CommonSortObject object
		sorttable = new CommonSortObject(document.getElementById(tableId), headerTypes);
	}
	alignHeaderTableAndContentTable("headerTableDivId",tableId);
}

function downloadbackupcfg(){
	document.getElementById(namespace_g + "myForm:download_backup_Cfg").click();
}

function cancelClick(dialogName){
	if("PoolAssignGlobal"==dialogName
	   ||"poolUnassignDedicated"==dialogName 
	   ||"poolAssignDedicated"==dialogName
	   ||"diskAssignDedicated"==dialogName){
		window.parent.closeUtilDialog();
		/*if('true'==document.getElementById(namespace_g + 'myForm:changeFlag').innerHTML){
			var poolWindow;
			if(parent.document.getElementById('iframe2').contentDocument){
				poolWindow = parent.document.getElementById('iframe2').contentDocument;
				poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
			}else{
				poolWindow = parent.document.getElementById('iframe2').contentWindow;
				poolWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();			
			}
						
			var diskWindow;
			if(parent.document.getElementById('iframe4').contentDocument){
				diskWindow = parent.document.getElementById('iframe4').contentDocument;
				diskWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/DisksTab.jsp";
			}else{
				diskWindow = parent.document.getElementById('iframe4').contentWindow;
				diskWindow.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
			}	
		}*/
		parent.refreshAllTabs(parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_DISK);
	}
}

function resetTableHeightOnError(dialogName){
	if("PoolAssignGlobal"==dialogName) {
		document.getElementById("blankRowTable").style.display = "none";
		document.getElementById("mainTableDiv").style.height= "150px";
	} else if("poolUnassignDedicated"==dialogName) {
		document.getElementById("mainTableDiv").style.height= "100px";
	} else if("poolAssignDedicated"==dialogName) {
		document.getElementById("mainTableDiv").style.height= "100px";
	} else if("diskAssignDedicated"==dialogName) {
		document.getElementById("leftTableDiv").style.height= "50px";
		document.getElementById("rightTableDiv").style.height= "50px";
	}
}

function onCompleteAction(dialogName, cancelBtnName){
	if("true" != document.getElementById(namespace_g + "myForm:innerMsgDisplay").innerHTML) {
		cancelClick(dialogName);
	} else {
		resetTableHeightOnError(dialogName);
		document.getElementById(cancelBtnName).disabled=false;
	}	
	
	hideProgressIndicator('spinningDiv');
}

// validate createVolume precondition from PoolsTab
function createVolumeFromPoolsTab(){
	var volumeNum = getVolumeSum();		
	if( volumeNum < maxQuantity){
		document.getElementById(namespace_g + "myForm:createVolumeBtn").click();
	}else{
		document.getElementById(namespace_g + "myForm:defineVolumeWarningPopuper").click();
	}
}

function getVolumeSum(){
	var i=0;
    var cellObj = null;
	var sum = 0;
    do{
		cellObj = document.getElementById(namespace_g + "myForm:storagePoolTable:"+i+":poolVolumes");
		if(cellObj!=null){
            try{
				sum+= Number(removeNbsp(cellObj.innerHTML));
			}catch(error){}
		}
      	i++;
	}while(cellObj!=null)
	
	return sum;
}

// validate createVolume precondition from VolumesTab
function createVolumeFromVolumesTab(){
	var volumeNum = document.getElementById(namespace_g + "myForm:volumeNumber").innerHTML;
	if( volumeNum < maxQuantity){
		document.getElementById(namespace_g + "myForm:createVolumeBtn_hidden").click();
	}else{
		document.getElementById(namespace_g + "myForm:defineVolumeWarningPopuper").click();
	}
}
/*
 * show error message for muti tab
 */ 
var loadSubTabTime = 0;
function showErrorMessageStorage() {
    loadSubTabTime ++;

    if( loadSubTabTime == Number(subTabCount)){
        loadSubTabTime = 0;
    	innerMessagesInstance.display();
	}
}
function appCfgShow(){
	document.getElementById(namespace_g + "myForm:apply_OkBtn").disabled = false;
	document.getElementById(namespace_g + "myForm:apply_CancelBtn").disabled = false;
	hideProgressIndicator('spinningDiv');
}
function onApplyConfig(){
	//document.getElementById(namespace_g + "myForm:action").innerHTML="true";
	document.getElementById(namespace_g + 'myForm:confirmHiddenBtn').click();
	/*parent.initCounter(5);
	
	if (!hX_5.brw.isIE()) {
		var volumeWindow = parent.document.getElementById('iframe1').contentDocument;
		volumeWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/VolumesTab.jsp";
		var poolWindow = parent.document.getElementById('iframe2').contentDocument;
		poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
		var hostWindow = parent.document.getElementById('hostIframe').contentDocument;
		hostWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/HostsTab.jsp";
		var diskWindow = parent.document.getElementById('iframe4').contentDocument;
		diskWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/DisksTab.jsp";
		
		document.getElementById(namespace_g + 'myForm:refreshBtn').click();
		
		//configWindow = parent.document.getElementById('cfgFrame').contentDocument;
		//configWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/ConfigModel.jsp";
	} else {
		parent.refreshTab("Configs");
		parent.refreshTab("Volumes");
		parent.refreshTab("Pools");
		parent.refreshTab("Hosts");
		parent.refreshTab("Disks");
		parent.requestRefresh();
	}*/
	parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_HOST+parent.REFRESH_MASK_DISK+parent.REFRESH_MASK_CONFIGURATION);
	enableAllStorageTabs();
}
function onDeleteAllConfmDlgShow(){
	document.getElementById(namespace_g + "myForm:deleteAll_OkBtn").disabled = false;
	document.getElementById(namespace_g + "myForm:deleteAll_CancelBtn").disabled = false;
	hideProgressIndicator('deleteAllSpinningDiv');
}
function deleteAllOkBtnClick(){
	document.getElementById(namespace_g + "myForm:deleteAll_OkBtn").disabled = true;
	document.getElementById(namespace_g + "myForm:deleteAll_CancelBtn").disabled = true;
}
function onDeleteAllConfig(){
	document.getElementById(namespace_g + 'myForm:hiddenCancelBtn').click();
	parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_HOST+parent.REFRESH_MASK_DISK+parent.REFRESH_MASK_CONFIGURATION);
	enableAllStorageTabs();
}
//////////////////////////////////////////////////go to ViewAlerts page//////////////////////////////////////////////
function gotoAlertsFromVolume(thisObj){
	syncCheckbox(false, "rowLinkHidden");
	syncCheckbox(false, "rowSelectShow");
	syncCheckbox(false, "rowLinkSelectHidden");
	var cns = thisObj.parentNode.parentNode.parentNode.parentNode.firstChild.firstChild.childNodes;		
	for(var i=0; i<cns.length; i++){
		var field = cns[i];
		if (field.type == "checkbox" && field.id.indexOf("rowSelectShow") > -1) {
			field.checked = true;
			break;
		}
	}
}
function gotoAlertsFromPool(thisObj){
	syncCheckbox(false, "rowLinkHidden");
	syncCheckbox(false, "rowSelect1");
	syncCheckbox(false, "rowLinkSelectHidden");
	var cns = thisObj.parentNode.parentNode.parentNode.parentNode.firstChild.firstChild.childNodes;		
	for(var i=0; i<cns.length; i++){
		var field = cns[i];
		if (field.type == "checkbox" && field.id.indexOf("rowSelect1") > -1) {
			field.checked = true;
			break;
		}
	}
}
function gotoAlertsFromDisk(thisObj){
	syncCheckbox(false, "rowSelect1");
	var cns = thisObj.parentNode.parentNode.parentNode.parentNode.firstChild.firstChild.childNodes;		
	for(var i=0; i<cns.length; i++){
		var field = cns[i];
		if (field.type == "checkbox" && field.id.indexOf("rowSelect1") > -1) {
			field.checked = true;
			break;
		}
	}
}
function clickLinkStatus(thisObj){
 if(document.title=="VolumesTab"){
 	gotoAlertsFromVolume(thisObj);
 }else if(document.title=="DisksTab"){
 	gotoAlertsFromDisk(thisObj);
 }else if(document.title=="PoolsTab"){
 	gotoAlertsFromPool(thisObj);
 }
	document.getElementById(namespace_g + "myForm").target="_parent";
	document.getElementById(namespace_g + "myForm:gotoViewAlertsPage").click();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// excludeIndex [1,5], otherwise will apply for all.
function enableSelectedStorageTabs(tabIndex){
	for(var i=1;i<=5;i++){
		if(i!=tabIndex){
			parent.ODCRegistry.getClientControl('tabbedPanelProperties').Panes[i].enabled = false;	
		}
	}
}
function enableAllStorageTabs(){
  setTimeout(lazyEnableAllStorageTabs,100);
}
function lazyEnableAllStorageTabs(){
	for(var i=1;i<=5;i++){
		if(parent.ODCRegistry) {
			parent.ODCRegistry.getClientControl('tabbedPanelProperties').Panes[i].enabled = true;	
		} else {
			ODCRegistry.getClientControl('tabbedPanelProperties').Panes[i].enabled = true;
		}
	}
}
/******************************************** Page Timeout functions **********************************************/
function sendTabLoadAjax(frameName) {
	 var tabiframe = document.getElementById(frameName);
	if (tabiframe) {
		tabiframe.contentWindow.document.getElementById(tabiframe.contentWindow.namespace_g + "myForm:onloadBehaviorBtn").click();
	}
}

function sendTabRefreshAjax(frameName) {
    var tabiframe = document.getElementById(frameName);
	if (tabiframe) {
		tabiframe.contentWindow.document.getElementById(tabiframe.contentWindow.namespace_g + "myForm:hiddenRefreshBtn").click();
	}
}


var refreshFrames;
var refreshTabCount;
var refreshCounter;
function initCounter(tabCount, mask) {
	refreshFrames = new Array();
	refreshTabCount = tabCount;
	refreshCounter = mask;
}

function TabAjaxComplete() {
	if (hX_5.brw.isIE()) {
		syncIncreaseConn();
	}
}

function loadFrame(frameName) {
	var frameObj = document.getElementById(frameName);
	if (frameName == "iframe1") {
		frameObj.contentWindow.enableVolumeBtn(false);
	}
	if (frameName == "iframe2") {
		frameObj.contentWindow.enablePoolButtons(false);
	}
	if (frameName == "hostIframe") {
		frameObj.contentWindow.onHostTableRefreshingStart();
		frameObj.contentWindow.enableHostsButtons(false);
	}
	if (frameName == "iframe4") {
		frameObj.contentWindow.enableDisksButtons(false);
	}
	if (frameName == "cfgFrame") {
		frameObj.contentWindow.enableConfigButtons(false);
	}
	
	if (refreshFrames.push(frameName) == refreshTabCount) {
		dispatchFrameLoadRequest();
	}
}

function dispatchFrameLoadRequest() {
	var connectionRemaining = Number(document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML);
	
	if (refreshFrames.length > 0) {
		if (connectionRemaining > 0) {
			var fName = refreshFrames.shift();
			sendTabLoadAjax(fName);
			syncDecreaseConn();
		}
		setTimeout(dispatchFrameLoadRequest , 250);
	}
}

function refreshTab(tabName) {
	if (tabName == "Volumes") {
		refreshFrame("iframe1");
	}
	
	if (tabName == "Pools") {
		refreshFrame("iframe2");
	}
	
	if (tabName == "Hosts") {
		refreshFrame("hostIframe");
	}
	
	if (tabName == "Disks") {
		refreshFrame("iframe4");
	}
	
	if (tabName == "Configs") {
		refreshFrame("cfgFrame");
	}
	
}

function refreshFrame(frameName) {
	refreshFrames.push(frameName);
}

var ajaxreq;
function requestRefresh() {
	var tabBits = 0;
	var frameObj;
	for (var i = 0;i < refreshFrames.length;i ++) {
		frameObj = document.getElementById(refreshFrames[i]);
		if (refreshFrames[i] == "iframe1") {
			tabBits += 1;
			frameObj.contentWindow.enableVolumeBtn(false);
		}
		
		if (refreshFrames[i] == "iframe2") {
			tabBits += 2;
			frameObj.contentWindow.enablePoolButtons(false);
		}
		
		if (refreshFrames[i] == "hostIframe") {
			tabBits += 4;
			frameObj.contentWindow.onHostTableRefreshingStart();
			frameObj.contentWindow.enableHostsButtons(false);
		}
		
		if (refreshFrames[i] == "iframe4") {
			tabBits += 8;
			frameObj.contentWindow.enableDisksButtons(false);
		}
		
		if (refreshFrames[i] == "cfgFrame") {
			tabBits += 16;
			frameObj.contentWindow.enableConfigButtons(false);
		}
		
		document.getElementById(refreshFrames[i]).contentWindow.disableRefreshButton(true);
		document.getElementById(refreshFrames[i]).contentWindow.displayMainContents(false);
	}
	
	if (window.XMLHttpRequest) {
		ajaxreq = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) {
	    try {
	      ajaxreq = new ActiveXObject("Msxml2.XMLHTTP");
	    } catch (e1) {
			try {
				ajaxreq = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e2) {
			}
	    }
	}
	
	ajaxreq.onreadystatechange = readyDispatch;
	
	var d = new Date();
	var longseconds = d.getTime();
	var urlbasepath = document.global_context_path;
	var url = urlbasepath + "/faces/page/rbce/storage/Storage.jsp?$$ajaxid=refreshPanel&$$ajaxmode=axpartial&bitMask=" + tabBits + "&timestamp=" + longseconds;
	ajaxreq.open("GET",url, true);
	ajaxreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	ajaxreq.send(null);
}

function readyDispatch() {
	if (ajaxreq.readyState == 4) {
		if (ajaxreq.status == 200) {
			dispatchFrameRefreshRequest();
		}
	}
}

function dispatchFrameRefreshRequest() {
	var connectionRemaining = Number(document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML);
	
	if (refreshFrames.length > 0) {
		if (connectionRemaining > 0) {
			syncDecreaseConn();
			sendTabRefreshAjax(refreshFrames.shift());
		}
		
		setTimeout(dispatchFrameRefreshRequest , 250);
	}
}

function syncIncreaseConn() {
	var conn = document.getElementById(namespace_g + "myForm:synchronizedFlag");
	if (conn.innerHTML == "false") {
		conn.innerHTML = "true";
		
		document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML = Number(document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML) + 1;
		
		conn.innerHTML = "false";
	} else {
		setTimeout(syncIncreaseConn , 50);
	}
}

function syncDecreaseConn() {
	var conn = document.getElementById(namespace_g + "myForm:synchronizedFlag");
	if (conn.innerHTML == "false") {
		conn.innerHTML = "true";
		
		document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML = Number(document.getElementById(namespace_g + "myForm:connectionFlag").innerHTML) - 1;
		
		conn.innerHTML = "false";
	} else {
		setTimeout(syncDecreaseConn , 50);
	}
}

function displayTab(){
	var tab = document.getElementById(namespace_g + 'myForm:selectedTabName').value;	
	if (tab.indexOf("view:") == -1)
	{
		tab = namespace_g + tab;
	}
	if(tab !=""){
		ODCRegistry.getClientControl('tabbedPanelProperties').restoreUIState(tab);
	}
}


//Tingwei's suggestion: to simplify the interface, we can define a function-tabsToBeRefreshed map which is maintained as
//a constant globally. This way, in each invokation of this util method, the invoker doesn't need to pass in the refresh 
//bit masks, instead the function ID as a constant should be used.
//Will consider this update during the JS refactory. (by David)
function refreshAllTabs(mask){
	disableRefreshButton(true);
	
	//alert('refresh '+mask);
	var count = 0;
	if ((mask & REFRESH_MASK_VOLUME) != 0) {
		count++;
	}
	if ((mask & REFRESH_MASK_POOL) != 0) {
		count++;
	}
	if ((mask & REFRESH_MASK_HOST) != 0) {
		count++;
	}
	if ((mask & REFRESH_MASK_DISK) != 0) {
		count++;
	}
	if ((mask & REFRESH_MASK_CONFIGURATION) != 0) {
		count++;
	}
	initCounter(count, mask);
	//alert(count);
	if (!hX_5.brw.isIE()) {
		//alert("!isIE");
		if ((mask & REFRESH_MASK_VOLUME) != 0) {
			//alert("REFRESH_MASK_VOLUME");
			var volumeWindow = document.getElementById('iframe1').contentDocument;
			volumeWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/VolumesTab.jsp";
		}
		if ((mask & REFRESH_MASK_POOL) != 0) {
			//alert("REFRESH_MASK_POOL");
			var poolWindow = document.getElementById('iframe2').contentDocument;
			poolWindow.location.href = document.global_context_path + "/faces/page/rbce/storage/PoolsTab.jsp";
		}
		if ((mask & REFRESH_MASK_HOST) != 0) {
			//alert("REFRESH_MASK_HOST");
			var hostWindow = document.getElementById('hostIframe').contentDocument;
			hostWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/HostsTab.jsp";
		}
		if ((mask & REFRESH_MASK_DISK) != 0) {
			//alert("REFRESH_MASK_DISK");
			var diskWindow = document.getElementById('iframe4').contentDocument;
			diskWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/DisksTab.jsp";
		}
		if ((mask & REFRESH_MASK_CONFIGURATION) != 0) {
			//alert("REFRESH_MASK_CONFIGURATION");
			var configWindow = document.getElementById('cfgFrame').contentDocument;
			configWindow.location.href=document.global_context_path + "/faces/page/rbce/storage/ConfigModel.jsp";
		}
	}else{
		if ((mask & REFRESH_MASK_VOLUME) != 0) {
			refreshTab("Volumes");
		}
		if ((mask & REFRESH_MASK_POOL) != 0) {
			refreshTab("Pools");
		}
		if ((mask & REFRESH_MASK_HOST) != 0) {
			refreshTab("Hosts");
		}
		if ((mask & REFRESH_MASK_DISK) != 0) {
			refreshTab("Disks");
		}
		if ((mask & REFRESH_MASK_CONFIGURATION) != 0) {
			refreshTab("Configs");
		}
		
		requestRefresh();
	}
}

function enableStorageRefreshButton(mask) {
	if((refreshCounter & mask) != 0) {
		refreshCounter = refreshCounter - mask;
	}
	if(refreshCounter == 0) {
		disableRefreshButton(false);
		setLastRefreshStamp();
	}
}

function MappedHosts_ShowDescription() {
	var showHosts = document.getElementById(namespace_g + "myForm:showHosts").innerHTML;
	if(showHosts == "true") {
		document.getElementById(namespace_g + "myForm:Volume_Mapped_Hosts_Hint_Text_ID").style.display = "block";
	}
}